/* DuplicityJob.c generated by valac 0.56.3, the Vala compiler
 * generated from DuplicityJob.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include "deja.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gpg-error.h>

#define DUPLICITY_JOB_MINIMUM_FULL 1
#define DUPLICITY_JOB_ERROR_GENERIC 1
#define DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED 3
#define DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND 19
#define DUPLICITY_JOB_ERROR_EXCEPTION 30
#define DUPLICITY_JOB_ERROR_GPG 31
#define DUPLICITY_JOB_ERROR_BAD_VOLUME 44
#define DUPLICITY_JOB_ERROR_BACKEND 50
#define DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED 51
#define DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND 52
#define DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE 53
#define DUPLICITY_JOB_INFO_PROGRESS 2
#define DUPLICITY_JOB_INFO_COLLECTION_STATUS 3
#define DUPLICITY_JOB_INFO_DIFF_FILE_NEW 4
#define DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED 5
#define DUPLICITY_JOB_INFO_DIFF_FILE_DELETED 6
#define DUPLICITY_JOB_INFO_PATCH_FILE_WRITING 7
#define DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING 8
#define DUPLICITY_JOB_INFO_FILE_STAT 10
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN 11
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN 12
#define DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_DONE 13
#define DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_DONE 14
#define DUPLICITY_JOB_WARNING_ORPHANED_SIG 2
#define DUPLICITY_JOB_WARNING_UNNECESSARY_SIG 3
#define DUPLICITY_JOB_WARNING_UNMATCHED_SIG 4
#define DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP 5
#define DUPLICITY_JOB_WARNING_ORPHANED_BACKUP 6
#define DUPLICITY_JOB_WARNING_CANNOT_STAT 9
#define DUPLICITY_JOB_WARNING_CANNOT_READ 10
#define DUPLICITY_JOB_WARNING_CANNOT_PROCESS 12
#define DUPLICITY_JOB_DEBUG_GENERIC 1

#define TYPE_DUPLICITY_JOB (duplicity_job_get_type ())
#define DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_JOB, DuplicityJob))
#define DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_JOB, DuplicityJobClass))
#define IS_DUPLICITY_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_JOB))
#define IS_DUPLICITY_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_JOB))
#define DUPLICITY_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_JOB, DuplicityJobClass))

typedef struct _DuplicityJob DuplicityJob;
typedef struct _DuplicityJobClass DuplicityJobClass;
typedef struct _DuplicityJobPrivate DuplicityJobPrivate;
typedef enum  {
	DUPLICITY_JOB_STATE_NOT_STARTED,
	DUPLICITY_JOB_STATE_NORMAL,
	DUPLICITY_JOB_STATE_DRY_RUN,
	DUPLICITY_JOB_STATE_STATUS,
	DUPLICITY_JOB_STATE_CLEANUP,
	DUPLICITY_JOB_STATE_DELETE
} DuplicityJobState;

#define DUPLICITY_JOB_TYPE_STATE (duplicity_job_state_get_type ())

#define TYPE_DUPLICITY_INSTANCE (duplicity_instance_get_type ())
#define DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstance))
#define DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))
#define IS_DUPLICITY_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICITY_INSTANCE))
#define IS_DUPLICITY_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICITY_INSTANCE))
#define DUPLICITY_INSTANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICITY_INSTANCE, DuplicityInstanceClass))

typedef struct _DuplicityInstance DuplicityInstance;
typedef struct _DuplicityInstanceClass DuplicityInstanceClass;

#define DUPLICITY_JOB_TYPE_DATE_INFO (duplicity_job_date_info_get_type ())
typedef struct _DuplicityJobDateInfo DuplicityJobDateInfo;
enum  {
	DUPLICITY_JOB_0_PROPERTY,
	DUPLICITY_JOB_STATE_PROPERTY,
	DUPLICITY_JOB_NUM_PROPERTIES
};
static GParamSpec* duplicity_job_properties[DUPLICITY_JOB_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DuplicityJobStartData DuplicityJobStartData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _DuplicityJobReportFullBackupsData DuplicityJobReportFullBackupsData;
typedef struct _DuplicityJobCheckBackupSpaceData DuplicityJobCheckBackupSpaceData;
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_tree_unref0(var) ((var == NULL) ? NULL : (var = (g_tree_unref (var), NULL)))

struct _DuplicityJob {
	DejaDupToolJob parent_instance;
	DuplicityJobPrivate * priv;
};

struct _DuplicityJobClass {
	DejaDupToolJobClass parent_class;
	void (*process_error) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text_in);
	void (*process_info) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text);
	void (*process_warning) (DuplicityJob* self, gchar** firstline, gint firstline_length1, GList* data, const gchar* text);
};

struct _DuplicityJobDateInfo {
	gboolean full;
	GDateTime* time;
};

struct _DuplicityJobPrivate {
	DejaDupToolJobMode _original_mode;
	gboolean _error_issued;
	gboolean _was_stopped;
	DuplicityJobState _state;
	DuplicityInstance* inst;
	GList* saved_argv;
	GList* saved_envp;
	gboolean is_full_backup;
	gboolean cleaned_up_once;
	gboolean detected_encryption;
	gboolean existing_encrypted;
	gchar* last_bad_volume;
	guint bad_volume_count;
	gboolean has_progress_total;
	guint64 progress_total;
	guint64 progress_count;
	gboolean checked_collection_info;
	gboolean got_collection_info;
	GList* collection_info;
	gboolean reported_full_backups;
	gboolean checked_backup_space;
	gboolean deleted_files;
	gint delete_age;
	GFile* last_touched_file;
	gchar* forced_cache_dir;
	gchar* credentials_dir;
	gchar* saved_status;
	GFile* saved_status_file;
	gboolean saved_status_file_action;
	gboolean restarted_without_cache;
};

struct _DuplicityJobStartData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	DejaDupToolJobMode _tmp2_;
	DejaDupToolJobMode _tmp3_;
	DejaDupFilteredSettings* settings;
	DejaDupFilteredSettings* _tmp4_;
	DejaDupFilteredSettings* _tmp5_;
	DejaDupToolJobFlags _tmp6_;
	DejaDupToolJobFlags _tmp7_;
	gchar* template;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	DejaDupBackend* _tmp15_;
	DejaDupBackend* _tmp16_;
	GError* e;
	GError* _tmp17_;
	const gchar* _tmp18_;
	DejaDupToolJobMode _tmp19_;
	DejaDupToolJobMode _tmp20_;
	DejaDupToolJobMode _tmp21_;
	DejaDupToolJobMode _tmp22_;
	DejaDupBackend* _tmp23_;
	DejaDupBackend* _tmp24_;
	DejaDupBackend* _tmp25_;
	DejaDupBackend* _tmp26_;
	DejaDupNetwork* _tmp27_;
	DejaDupNetwork* _tmp28_;
	DejaDupNetwork* _tmp29_;
	DejaDupNetwork* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	gboolean _tmp33_;
	GError* _inner_error0_;
};

struct _DuplicityJobReportFullBackupsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	GDateTime* full_backup;
	GList* _tmp0_;
	GList* info_collection;
	GList* info_it;
	DuplicityJobDateInfo _tmp1_;
	DuplicityJobDateInfo _tmp2_;
	DuplicityJobDateInfo info;
	DuplicityJobDateInfo _tmp3_;
	DuplicityJobDateInfo _tmp4_;
	GDateTime* _tmp5_;
	GDateTime* _tmp6_;
	gboolean first_backup;
	GDateTime* _tmp7_;
	GDateTime* threshold;
	GDateTime* _tmp8_;
	gboolean _tmp9_;
	GDateTime* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	gboolean _tmp13_;
	DejaDupToolJobMode _tmp14_;
	DejaDupToolJobMode _tmp15_;
};

struct _DuplicityJobCheckBackupSpaceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DuplicityJob* self;
	gchar* formatted_progress_total;
	gchar* _tmp0_;
	guint64 free;
	DejaDupBackend* _tmp1_;
	DejaDupBackend* _tmp2_;
	guint64 total;
	DejaDupBackend* _tmp3_;
	DejaDupBackend* _tmp4_;
	gboolean _tmp5_;
	gchar* msg;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint full_dates;
	GList* _tmp11_;
	GList* info_collection;
	GList* info_it;
	DuplicityJobDateInfo _tmp12_;
	DuplicityJobDateInfo _tmp13_;
	DuplicityJobDateInfo info;
	DuplicityJobDateInfo _tmp14_;
	gint _tmp15_;
	gchar* _vala1_msg;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
};

static gint DuplicityJob_private_offset;
static gpointer duplicity_job_parent_class = NULL;
static GFile* duplicity_job_slash;
static GFile* duplicity_job_slash = NULL;

VALA_EXTERN GType duplicity_job_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType duplicity_job_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType duplicity_instance_get_type (void) G_GNUC_CONST ;
static GType duplicity_job_date_info_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static DuplicityJobDateInfo* duplicity_job_date_info_dup (const DuplicityJobDateInfo* self);
static void duplicity_job_date_info_free (DuplicityJobDateInfo* self);
static void duplicity_job_date_info_copy (const DuplicityJobDateInfo* self,
                                   DuplicityJobDateInfo* dest);
static void duplicity_job_date_info_destroy (DuplicityJobDateInfo* self);
VALA_EXTERN void duplicity_job_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  gint firstline_length1,
                                  GList* data,
                                  const gchar* text_in);
VALA_EXTERN void duplicity_job_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 gint firstline_length1,
                                 GList* data,
                                 const gchar* text);
VALA_EXTERN void duplicity_job_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    gint firstline_length1,
                                    GList* data,
                                    const gchar* text);
static void duplicity_job_network_changed (DuplicityJob* self);
static void _duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void duplicity_job_clean_credentials_dir (DuplicityJob* self);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
static void _duplicity_job_date_info_free0_ (gpointer var);
static inline void _g_list_free__duplicity_job_date_info_free0_ (GList* self);
static void duplicity_job_real_start_data_free (gpointer _data);
static void duplicity_job_real_start (DejaDupToolJob* base,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean duplicity_job_real_start_co (DuplicityJobStartData* _data_);
static DejaDupToolJobMode duplicity_job_get_original_mode (DuplicityJob* self);
static void duplicity_job_set_original_mode (DuplicityJob* self,
                                      DejaDupToolJobMode value);
static void duplicity_job_start_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_);
static void duplicity_job_fill_envp_from_backend (DuplicityJob* self,
                                           GError** error);
static void duplicity_job_process_include_excludes (DuplicityJob* self);
static gboolean duplicity_job_restart (DuplicityJob* self);
static gint duplicity_job_cmp_prefix (DuplicityJob* self,
                               GFile* a,
                               GFile* b);
static void duplicity_job_fill_envp_from_google (DuplicityJob* self,
                                          DejaDupBackendGoogle* google_backend,
                                          GError** error);
static void duplicity_job_fill_envp_from_microsoft (DuplicityJob* self,
                                             DejaDupBackendMicrosoft* microsoft_backend);
static gchar* duplicity_job_get_remote (DuplicityJob* self);
VALA_EXTERN GFile* deja_dup_backend_file_get_file_from_settings (DejaDupBackendFile* self);
VALA_EXTERN gchar* deja_dup_backend_microsoft_get_folder (DejaDupBackendMicrosoft* self);
static gchar* duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                            const gchar* path);
static gchar* duplicity_job_prefix_local (DuplicityJob* self,
                                   const gchar* path);
VALA_EXTERN void deja_dup_expand_links_in_list (GList** all,
                                    gboolean keep_internal);
static void duplicity_job_real_cancel (DejaDupToolJob* base);
VALA_EXTERN DuplicityJobState duplicity_job_get_state (DuplicityJob* self);
static gboolean duplicity_job_cleanup (DuplicityJob* self);
static void duplicity_job_cancel_inst (DuplicityJob* self);
static void duplicity_job_real_stop (DejaDupToolJob* base);
static void duplicity_job_set_was_stopped (DuplicityJob* self,
                                    gboolean value);
static void duplicity_job_real_pause (DejaDupToolJob* base,
                               const gchar* reason);
VALA_EXTERN void duplicity_instance_pause (DuplicityInstance* self);
static void duplicity_job_set_status (DuplicityJob* self,
                               const gchar* msg,
                               gboolean save);
static void duplicity_job_real_resume (DejaDupToolJob* base);
VALA_EXTERN void duplicity_instance_resume (DuplicityInstance* self);
static void duplicity_job_set_saved_status (DuplicityJob* self);
static void duplicity_job_disconnect_inst (DuplicityJob* self);
static void duplicity_job_handle_done (DuplicityJob* self,
                                DuplicityInstance* inst,
                                gboolean success,
                                gboolean cancelled);
VALA_EXTERN void duplicity_job_set_state (DuplicityJob* self,
                              DuplicityJobState value);
static void duplicity_job_report_full_backups (DuplicityJob* self,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
static void duplicity_job_report_full_backups_finish (DuplicityJob* self,
                                               GAsyncResult* _res_);
static void duplicity_job_check_backup_space (DuplicityJob* self,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static void duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                              GAsyncResult* _res_);
static void duplicity_job_delete_cache (DuplicityJob* self,
                                 GRegex* only);
static GFile* duplicity_job_make_local_rel_path (DuplicityJob* self,
                                          GFile* file);
static void duplicity_job_show_error (DuplicityJob* self,
                               const gchar* errorstr,
                               const gchar* detail);
static void duplicity_job_connect_and_start (DuplicityJob* self,
                                      GList* argv_extra,
                                      GList* envp_extra,
                                      GList* argv_entire,
                                      GFile* custom_local);
static void duplicity_job_report_full_backups_data_free (gpointer _data);
static gboolean duplicity_job_report_full_backups_co (DuplicityJobReportFullBackupsData* _data_);
static void duplicity_job_check_backup_space_data_free (gpointer _data);
static gboolean duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_);
static void duplicity_job_check_backup_space_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void duplicity_job_delete_excess (DuplicityJob* self,
                                  gint cutoff);
static gboolean duplicity_job_can_ignore_error (DuplicityJob* self);
static gboolean duplicity_job_delete_files_if_needed (DuplicityJob* self);
static gboolean duplicity_job_get_was_stopped (DuplicityJob* self);
static gboolean duplicity_job_get_error_issued (DuplicityJob* self);
static void duplicity_job_set_status_file (DuplicityJob* self,
                                    GFile* file,
                                    gboolean action,
                                    gboolean save);
static gboolean duplicity_job_restart_without_cache (DuplicityJob* self);
static void duplicity_job_handle_exit (DuplicityJob* self,
                                gint code);
static void duplicity_job_handle_message (DuplicityJob* self,
                                   DuplicityInstance* inst,
                                   gchar** control_line,
                                   gint control_line_length1,
                                   GList* data_lines,
                                   const gchar* user_text);
static gboolean duplicity_job_ask_question (DuplicityJob* self,
                                     const gchar* t,
                                     const gchar* m);
static gchar* duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                           const gchar* file,
                                           gint skip_bits);
static void duplicity_job_report_encryption_error (DuplicityJob* self);
static gboolean duplicity_job_check_encryption_error (DuplicityJob* self,
                                               const gchar* text);
static void duplicity_job_real_process_error (DuplicityJob* self,
                                       gchar** firstline,
                                       gint firstline_length1,
                                       GList* data,
                                       const gchar* text_in);
static void duplicity_job_process_exception (DuplicityJob* self,
                                      const gchar* exception,
                                      const gchar* text);
static GFile* duplicity_job_make_file_obj (DuplicityJob* self,
                                    const gchar* file);
static void duplicity_job_real_process_info (DuplicityJob* self,
                                      gchar** firstline,
                                      gint firstline_length1,
                                      GList* data,
                                      const gchar* text);
static void duplicity_job_process_diff_file (DuplicityJob* self,
                                      const gchar* file);
static void duplicity_job_process_patch_file (DuplicityJob* self,
                                       const gchar* file);
static void duplicity_job_process_progress (DuplicityJob* self,
                                     gchar** firstline,
                                     gint firstline_length1);
static void duplicity_job_process_collection_status (DuplicityJob* self,
                                              GList* lines);
static void duplicity_job_process_file_stat (DuplicityJob* self,
                                      const gchar* date,
                                      const gchar* file,
                                      const gchar* dup_type,
                                      GList* data,
                                      const gchar* text);
static gint __lambda18_ (DuplicityJob* self,
                  GDateTime* a,
                  GDateTime* b);
static gint ___lambda18__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static void _g_date_time_unref0_ (gpointer var);
static gboolean duplicity_job_is_file_in_list (DuplicityJob* self,
                                        GFile* file,
                                        GList* list);
static gboolean duplicity_job_is_file_in_or_under_list (DuplicityJob* self,
                                                 GFile* file,
                                                 GList* list);
static void duplicity_job_real_process_warning (DuplicityJob* self,
                                         gchar** firstline,
                                         gint firstline_length1,
                                         GList* data,
                                         const gchar* text);
static void duplicity_job_set_error_issued (DuplicityJob* self,
                                     gboolean value);
static gint duplicity_job_get_volsize (DuplicityJob* self);
static void _duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                         gboolean success,
                                                         gboolean cancelled,
                                                         gpointer self);
static void _duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                               gchar** control_line,
                                                               gint control_line_length1,
                                                               GList* data_lines,
                                                               const gchar* user_text,
                                                               gpointer self);
static void _duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                           gint code,
                                                           gpointer self);
VALA_EXTERN void duplicity_instance_cancel (DuplicityInstance* self);
VALA_EXTERN DuplicityInstance* duplicity_instance_new (void);
VALA_EXTERN DuplicityInstance* duplicity_instance_construct (GType object_type);
VALA_EXTERN void duplicity_instance_set_forced_cache_dir (DuplicityInstance* self,
                                              const gchar* value);
VALA_EXTERN void duplicity_instance_start (DuplicityInstance* self,
                               GList* argv_in,
                               GList* envp_in,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
VALA_EXTERN void duplicity_instance_start_finish (DuplicityInstance* self,
                                      GAsyncResult* _res_);
VALA_EXTERN DuplicityJob* duplicity_job_new (void);
VALA_EXTERN DuplicityJob* duplicity_job_construct (GType object_type);
static GObject * duplicity_job_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void duplicity_job_finalize (GObject * obj);
static GType duplicity_job_get_type_once (void);
static void _vala_duplicity_job_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_duplicity_job_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
duplicity_job_get_instance_private (DuplicityJob* self)
{
	return G_STRUCT_MEMBER_P (self, DuplicityJob_private_offset);
}

static void
_duplicity_job_network_changed_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_network_changed ((DuplicityJob*) self);
#line 533 "DuplicityJob.c"
}

 G_GNUC_NO_INLINE static GType
duplicity_job_state_get_type_once (void)
{
	static const GEnumValue values[] = {{DUPLICITY_JOB_STATE_NOT_STARTED, "DUPLICITY_JOB_STATE_NOT_STARTED", "not-started"}, {DUPLICITY_JOB_STATE_NORMAL, "DUPLICITY_JOB_STATE_NORMAL", "normal"}, {DUPLICITY_JOB_STATE_DRY_RUN, "DUPLICITY_JOB_STATE_DRY_RUN", "dry-run"}, {DUPLICITY_JOB_STATE_STATUS, "DUPLICITY_JOB_STATE_STATUS", "status"}, {DUPLICITY_JOB_STATE_CLEANUP, "DUPLICITY_JOB_STATE_CLEANUP", "cleanup"}, {DUPLICITY_JOB_STATE_DELETE, "DUPLICITY_JOB_STATE_DELETE", "delete"}, {0, NULL, NULL}};
	GType duplicity_job_state_type_id;
	duplicity_job_state_type_id = g_enum_register_static ("DuplicityJobState", values);
	return duplicity_job_state_type_id;
}

GType
duplicity_job_state_get_type (void)
{
	static gsize duplicity_job_state_type_id__once = 0;
	if (g_once_init_enter (&duplicity_job_state_type_id__once)) {
		GType duplicity_job_state_type_id;
		duplicity_job_state_type_id = duplicity_job_state_get_type_once ();
		g_once_init_leave (&duplicity_job_state_type_id__once, duplicity_job_state_type_id);
	}
	return duplicity_job_state_type_id__once;
}

static void
_g_free0_ (gpointer var)
{
#line 27 "../libdeja/duplicity/DuplicityJob.vala"
	var = (g_free (var), NULL);
#line 562 "DuplicityJob.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 27 "../libdeja/duplicity/DuplicityJob.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 570 "DuplicityJob.c"
}

static void
_duplicity_job_date_info_free0_ (gpointer var)
{
#line 49 "../libdeja/duplicity/DuplicityJob.vala"
	(var == NULL) ? NULL : (var = (duplicity_job_date_info_free (var), NULL));
#line 578 "DuplicityJob.c"
}

static inline void
_g_list_free__duplicity_job_date_info_free0_ (GList* self)
{
#line 49 "../libdeja/duplicity/DuplicityJob.vala"
	g_list_free_full (self, (GDestroyNotify) _duplicity_job_date_info_free0_);
#line 586 "DuplicityJob.c"
}

static void
duplicity_job_network_changed (DuplicityJob* self)
{
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 63 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_network_get ();
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = deja_dup_network_get_connected (_tmp1_);
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = _tmp3_;
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp1_);
#line 65 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp4_) {
#line 66 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_tool_job_resume ((DejaDupToolJob*) self);
#line 615 "DuplicityJob.c"
	} else {
#line 68 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_tool_job_pause ((DejaDupToolJob*) self, _ ("Paused (no network)"));
#line 619 "DuplicityJob.c"
	}
}

static void
duplicity_job_clean_credentials_dir (DuplicityJob* self)
{
	const gchar* _tmp0_;
#line 82 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 83 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->credentials_dir;
#line 83 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 633 "DuplicityJob.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 84 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->credentials_dir;
#line 84 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = g_strdup_printf ("%s/settings.yaml", _tmp1_);
#line 84 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = _tmp2_;
#line 84 "../libdeja/duplicity/DuplicityJob.vala"
		g_remove (_tmp3_);
#line 84 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp3_);
#line 85 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = self->priv->credentials_dir;
#line 85 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = g_strdup_printf ("%s/credentials.json", _tmp4_);
#line 85 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = _tmp5_;
#line 85 "../libdeja/duplicity/DuplicityJob.vala"
		g_remove (_tmp6_);
#line 85 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp6_);
#line 86 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = self->priv->credentials_dir;
#line 86 "../libdeja/duplicity/DuplicityJob.vala"
		g_remove (_tmp7_);
#line 87 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (self->priv->credentials_dir);
#line 87 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->credentials_dir = NULL;
#line 669 "DuplicityJob.c"
	}
}

static void
duplicity_job_real_start_data_free (gpointer _data)
{
	DuplicityJobStartData* _data_;
	_data_ = _data;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobStartData, _data_);
#line 682 "DuplicityJob.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	return self ? g_object_ref (self) : NULL;
#line 690 "DuplicityJob.c"
}

static void
duplicity_job_real_start (DejaDupToolJob* base,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	DuplicityJob * self;
	DuplicityJobStartData* _data_;
	DuplicityJob* _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobStartData);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_real_start_data_free);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_real_start_co (_data_);
#line 715 "DuplicityJob.c"
}

static void
duplicity_job_start_finish (DejaDupToolJob* base,
                            GAsyncResult* _res_)
{
	DuplicityJobStartData* _data_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 725 "DuplicityJob.c"
}

static void
duplicity_job_start_ready (GObject* source_object,
                           GAsyncResult* _res_,
                           gpointer _user_data_)
{
	DuplicityJobStartData* _data_;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = _user_data_;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_source_object_ = source_object;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_res_ = _res_;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_real_start_co (_data_);
#line 742 "DuplicityJob.c"
}

static gboolean
duplicity_job_real_start_co (DuplicityJobStartData* _data_)
{
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
		case 0:
#line 752 "DuplicityJob.c"
		goto _state_0;
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
		case 1:
#line 756 "DuplicityJob.c"
		goto _state_1;
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
		case 2:
#line 760 "DuplicityJob.c"
		goto _state_2;
		default:
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 765 "DuplicityJob.c"
	}
	_state_0:
#line 94 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = _data_->self->priv->_original_mode;
#line 94 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp0_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 95 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) _data_->self);
#line 95 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 95 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_original_mode (_data_->self, _data_->_tmp2_);
#line 778 "DuplicityJob.c"
	}
#line 96 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp3_ = _data_->self->priv->_original_mode;
#line 96 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) _data_->self, _data_->_tmp3_);
#line 97 "../libdeja/duplicity/DuplicityJob.vala"
	(_data_->self->priv->saved_argv == NULL) ? NULL : (_data_->self->priv->saved_argv = (_g_list_free__g_free0_ (_data_->self->priv->saved_argv), NULL));
#line 97 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self->priv->saved_argv = NULL;
#line 98 "../libdeja/duplicity/DuplicityJob.vala"
	(_data_->self->priv->saved_envp == NULL) ? NULL : (_data_->self->priv->saved_envp = (_g_list_free__g_free0_ (_data_->self->priv->saved_envp), NULL));
#line 98 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self->priv->saved_envp = NULL;
#line 100 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp4_ = deja_dup_get_settings (NULL);
#line 100 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->settings = _data_->_tmp4_;
#line 101 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp5_ = _data_->settings;
#line 101 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self->priv->delete_age = g_settings_get_int ((GSettings*) _data_->_tmp5_, DEJA_DUP_DELETE_AFTER_KEY);
#line 104 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp6_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) _data_->self);
#line 104 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 104 "../libdeja/duplicity/DuplicityJob.vala"
	if ((_data_->_tmp7_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_CACHE) != 0) {
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_state_ = 1;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_get_tempdir (duplicity_job_start_ready, _data_);
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 812 "DuplicityJob.c"
		_state_1:
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp8_ = deja_dup_get_tempdir_finish (_data_->_res_);
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = g_build_filename (_data_->_tmp9_, "duplicity-XXXXXX", NULL);
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->_tmp9_);
#line 106 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->template = _data_->_tmp11_;
#line 107 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp12_ = _data_->template;
#line 107 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp13_ = g_strdup (_data_->_tmp12_);
#line 107 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp14_ = mkdtemp (_data_->_tmp13_);
#line 107 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->self->priv->forced_cache_dir);
#line 107 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->self->priv->forced_cache_dir = _data_->_tmp14_;
#line 104 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->template);
#line 838 "DuplicityJob.c"
	}
	{
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp15_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_state_ = 2;
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_backend_prepare (_data_->_tmp16_, duplicity_job_start_ready, _data_);
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 851 "DuplicityJob.c"
		_state_2:
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_backend_prepare_finish (_data_->_tmp16_, _data_->_res_, &_data_->_inner_error0_);
#line 112 "../libdeja/duplicity/DuplicityJob.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 857 "DuplicityJob.c"
			goto __catch0_g_error;
		}
#line 113 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_fill_envp_from_backend (_data_->self, &_data_->_inner_error0_);
#line 113 "../libdeja/duplicity/DuplicityJob.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 864 "DuplicityJob.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->e = _data_->_inner_error0_;
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_inner_error0_ = NULL;
#line 116 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp17_ = _data_->e;
#line 116 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp18_ = _data_->_tmp17_->message;
#line 116 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "raise-error", _data_->_tmp18_, NULL);
#line 117 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		_g_error_free0 (_data_->e);
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_data_->settings);
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 895 "DuplicityJob.c"
			}
		}
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 118 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 902 "DuplicityJob.c"
	}
	__finally0:
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_data_->settings);
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 111 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 917 "DuplicityJob.c"
	}
#line 121 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp19_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) _data_->self);
#line 121 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 121 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp20_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_data_->settings);
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 935 "DuplicityJob.c"
			}
		}
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 122 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 942 "DuplicityJob.c"
	}
#line 126 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp21_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) _data_->self);
#line 126 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 126 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp22_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 127 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp23_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 127 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 127 "../libdeja/duplicity/DuplicityJob.vala"
		deja_dup_backend_add_excludes (_data_->_tmp24_, &((DejaDupToolJob*) _data_->self)->excludes);
#line 128 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_process_include_excludes (_data_->self);
#line 958 "DuplicityJob.c"
	}
#line 131 "../libdeja/duplicity/DuplicityJob.vala"
	if (!duplicity_job_restart (_data_->self)) {
#line 132 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 964 "DuplicityJob.c"
	}
#line 134 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp25_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 134 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 134 "../libdeja/duplicity/DuplicityJob.vala"
	if (!deja_dup_backend_is_native (_data_->_tmp26_)) {
#line 135 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp27_ = deja_dup_network_get ();
#line 135 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 135 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_connect_object ((GObject*) _data_->_tmp28_, "notify::connected", (GCallback) _duplicity_job_network_changed_g_object_notify, _data_->self, 0);
#line 135 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_data_->_tmp28_);
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp29_ = deja_dup_network_get ();
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp31_ = deja_dup_network_get_connected (_data_->_tmp30_);
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp33_ = !_data_->_tmp32_;
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (_data_->_tmp30_);
#line 136 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->_tmp33_) {
#line 137 "../libdeja/duplicity/DuplicityJob.vala"
			g_debug ("DuplicityJob.vala:137: No connection found. Postponing the backup.");
#line 138 "../libdeja/duplicity/DuplicityJob.vala"
			deja_dup_tool_job_pause ((DejaDupToolJob*) _data_->self, _ ("Paused (no network)"));
#line 998 "DuplicityJob.c"
		}
	}
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->settings);
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1011 "DuplicityJob.c"
		}
	}
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 91 "../libdeja/duplicity/DuplicityJob.vala"
	return FALSE;
#line 1018 "DuplicityJob.c"
}

static gint
duplicity_job_cmp_prefix (DuplicityJob* self,
                          GFile* a,
                          GFile* b)
{
	gboolean _tmp0_ = FALSE;
	gint result;
#line 144 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 146 "../libdeja/duplicity/DuplicityJob.vala"
	if (a == NULL) {
#line 146 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = b == NULL;
#line 1034 "DuplicityJob.c"
	} else {
#line 146 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 1038 "DuplicityJob.c"
	}
#line 146 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 147 "../libdeja/duplicity/DuplicityJob.vala"
		result = 0;
#line 147 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 1046 "DuplicityJob.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 148 "../libdeja/duplicity/DuplicityJob.vala"
		if (b == NULL) {
#line 148 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp1_ = TRUE;
#line 1053 "DuplicityJob.c"
		} else {
#line 148 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp1_ = g_file_has_prefix (a, b);
#line 1057 "DuplicityJob.c"
		}
#line 148 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp1_) {
#line 149 "../libdeja/duplicity/DuplicityJob.vala"
			result = -1;
#line 149 "../libdeja/duplicity/DuplicityJob.vala"
			return result;
#line 1065 "DuplicityJob.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 150 "../libdeja/duplicity/DuplicityJob.vala"
			if (a == NULL) {
#line 150 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = TRUE;
#line 1072 "DuplicityJob.c"
			} else {
#line 150 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = g_file_has_prefix (b, a);
#line 1076 "DuplicityJob.c"
			}
#line 150 "../libdeja/duplicity/DuplicityJob.vala"
			if (_tmp2_) {
#line 151 "../libdeja/duplicity/DuplicityJob.vala"
				result = 1;
#line 151 "../libdeja/duplicity/DuplicityJob.vala"
				return result;
#line 1084 "DuplicityJob.c"
			} else {
#line 153 "../libdeja/duplicity/DuplicityJob.vala"
				result = 0;
#line 153 "../libdeja/duplicity/DuplicityJob.vala"
				return result;
#line 1090 "DuplicityJob.c"
			}
		}
	}
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1543 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 1115 "DuplicityJob.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 1119 "DuplicityJob.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 1125 "DuplicityJob.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 1129 "DuplicityJob.c"
	}
#line 1543 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1133 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1544 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1544 "glib-2.0.vapi"
		result = _tmp2_;
#line 1544 "glib-2.0.vapi"
		return result;
#line 1141 "DuplicityJob.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1547 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1547 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1547 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1547 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1547 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1547 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1547 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1547 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1169 "DuplicityJob.c"
				goto __catch0_g_regex_error;
			}
#line 1547 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1547 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1547 "glib-2.0.vapi"
			return NULL;
#line 1178 "DuplicityJob.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1548 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1548 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1548 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1548 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1192 "DuplicityJob.c"
				goto __catch0_g_regex_error;
			}
#line 1548 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1548 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1548 "glib-2.0.vapi"
			return NULL;
#line 1201 "DuplicityJob.c"
		}
#line 1548 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1548 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1548 "glib-2.0.vapi"
		result = _tmp10_;
#line 1548 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1548 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1548 "glib-2.0.vapi"
		return result;
#line 1215 "DuplicityJob.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1546 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1550 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1224 "DuplicityJob.c"
	}
	__finally0:
#line 1546 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1546 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1546 "glib-2.0.vapi"
	return NULL;
#line 1233 "DuplicityJob.c"
}

static void
duplicity_job_fill_envp_from_google (DuplicityJob* self,
                                     DejaDupBackendGoogle* google_backend,
                                     GError** error)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* yaml_path = NULL;
	gchar* _tmp3_;
	GBytes* yaml_bytes = NULL;
	const gchar* _tmp4_;
	GBytes* _tmp5_;
	gchar* yaml = NULL;
	GBytes* _tmp6_;
	gsize _tmp7_ = 0;
	guint8* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* json_path = NULL;
	gchar* _tmp19_;
	GBytes* json_bytes = NULL;
	const gchar* _tmp20_;
	GBytes* _tmp21_;
	gchar* json = NULL;
	GBytes* _tmp22_;
	gsize _tmp23_ = 0;
	guint8* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GError* _inner_error0_ = NULL;
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (google_backend != NULL);
#line 163 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_clean_credentials_dir (self);
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_dir_make_tmp ("deja-dup-XXXXXX", &_inner_error0_);
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = _tmp1_;
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
		g_propagate_error (error, _inner_error0_);
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 1306 "DuplicityJob.c"
	}
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _tmp0_;
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = NULL;
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->credentials_dir);
#line 165 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->credentials_dir = _tmp2_;
#line 168 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = g_strdup ("/org/gnome/DejaDup/pydrive-settings.yaml");
#line 168 "../libdeja/duplicity/DuplicityJob.vala"
	yaml_path = _tmp3_;
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = yaml_path;
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = g_resources_lookup_data (_tmp4_, G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
	yaml_bytes = _tmp5_;
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
		g_propagate_error (error, _inner_error0_);
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml_path);
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp0_);
#line 169 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 1336 "DuplicityJob.c"
	}
#line 170 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp6_ = yaml_bytes;
#line 170 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp8_ = g_bytes_get_data (_tmp6_, &_tmp7_);
#line 170 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 170 "../libdeja/duplicity/DuplicityJob.vala"
	yaml = _tmp9_;
#line 171 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp10_ = yaml;
#line 171 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp11_ = string_replace (_tmp10_, "$CLIENT_ID", GOOGLE_CLIENT_ID);
#line 171 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (yaml);
#line 171 "../libdeja/duplicity/DuplicityJob.vala"
	yaml = _tmp11_;
#line 172 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp12_ = yaml;
#line 172 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp13_ = self->priv->credentials_dir;
#line 172 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp14_ = string_replace (_tmp12_, "$PATH", _tmp13_);
#line 172 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (yaml);
#line 172 "../libdeja/duplicity/DuplicityJob.vala"
	yaml = _tmp14_;
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp15_ = self->priv->credentials_dir;
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp16_ = g_strdup_printf ("%s/settings.yaml", _tmp15_);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp17_ = _tmp16_;
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp18_ = yaml;
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	g_file_set_contents (_tmp17_, _tmp18_, (gssize) -1, &_inner_error0_);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_tmp17_);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		g_propagate_error (error, _inner_error0_);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		_g_bytes_unref0 (yaml_bytes);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml_path);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp0_);
#line 173 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 1390 "DuplicityJob.c"
	}
#line 176 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp19_ = g_strdup ("/org/gnome/DejaDup/pydrive-credentials.json");
#line 176 "../libdeja/duplicity/DuplicityJob.vala"
	json_path = _tmp19_;
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp20_ = json_path;
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp21_ = g_resources_lookup_data (_tmp20_, G_RESOURCE_LOOKUP_FLAGS_NONE, &_inner_error0_);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
	json_bytes = _tmp21_;
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		g_propagate_error (error, _inner_error0_);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (json_path);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		_g_bytes_unref0 (yaml_bytes);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml_path);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp0_);
#line 177 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 1418 "DuplicityJob.c"
	}
#line 178 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp22_ = json_bytes;
#line 178 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp24_ = g_bytes_get_data (_tmp22_, &_tmp23_);
#line 178 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp25_ = g_strdup ((const gchar*) _tmp24_);
#line 178 "../libdeja/duplicity/DuplicityJob.vala"
	json = _tmp25_;
#line 179 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp26_ = json;
#line 179 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp27_ = string_replace (_tmp26_, "$CLIENT_ID", GOOGLE_CLIENT_ID);
#line 179 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (json);
#line 179 "../libdeja/duplicity/DuplicityJob.vala"
	json = _tmp27_;
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp28_ = json;
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp29_ = deja_dup_backend_oauth_get_access_token ((DejaDupBackendOAuth*) google_backend);
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp30_ = _tmp29_;
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp31_ = string_replace (_tmp28_, "$ACCESS_TOKEN", _tmp30_);
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (json);
#line 180 "../libdeja/duplicity/DuplicityJob.vala"
	json = _tmp31_;
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp32_ = json;
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp33_ = deja_dup_backend_oauth_get_refresh_token ((DejaDupBackendOAuth*) google_backend);
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp34_ = _tmp33_;
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp35_ = string_replace (_tmp32_, "$REFRESH_TOKEN", _tmp34_);
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (json);
#line 181 "../libdeja/duplicity/DuplicityJob.vala"
	json = _tmp35_;
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp36_ = self->priv->credentials_dir;
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp37_ = g_strdup_printf ("%s/credentials.json", _tmp36_);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp38_ = _tmp37_;
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp39_ = json;
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	g_file_set_contents (_tmp38_, _tmp39_, (gssize) -1, &_inner_error0_);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_tmp38_);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		g_propagate_error (error, _inner_error0_);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (json);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_bytes_unref0 (json_bytes);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (json_path);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_bytes_unref0 (yaml_bytes);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (yaml_path);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp0_);
#line 182 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 1492 "DuplicityJob.c"
	}
#line 184 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp40_ = self->priv->credentials_dir;
#line 184 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp41_ = g_strdup_printf ("GOOGLE_DRIVE_SETTINGS=%s/settings.yaml", _tmp40_);
#line 184 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_envp = g_list_append (self->priv->saved_envp, _tmp41_);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (json);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_bytes_unref0 (json_bytes);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (json_path);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (yaml);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_bytes_unref0 (yaml_bytes);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (yaml_path);
#line 156 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_tmp0_);
#line 1514 "DuplicityJob.c"
}

static void
duplicity_job_fill_envp_from_microsoft (DuplicityJob* self,
                                        DejaDupBackendMicrosoft* microsoft_backend)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
#line 187 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 187 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (microsoft_backend != NULL);
#line 189 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = g_strdup_printf ("OAUTH2_CLIENT_ID=%s", MICROSOFT_CLIENT_ID);
#line 189 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_envp = g_list_append (self->priv->saved_envp, _tmp0_);
#line 190 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = deja_dup_backend_oauth_get_refresh_token ((DejaDupBackendOAuth*) microsoft_backend);
#line 190 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _tmp1_;
#line 190 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = g_strdup_printf ("OAUTH2_REFRESH_TOKEN=%s", _tmp2_);
#line 190 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_envp = g_list_append (self->priv->saved_envp, _tmp3_);
#line 1541 "DuplicityJob.c"
}

static void
duplicity_job_fill_envp_from_backend (DuplicityJob* self,
                                      GError** error)
{
	DejaDupBackendGoogle* google_backend = NULL;
	DejaDupBackend* _tmp0_;
	DejaDupBackend* _tmp1_;
	DejaDupBackendGoogle* _tmp2_;
	DejaDupBackendGoogle* _tmp3_;
	DejaDupBackendMicrosoft* microsoft_backend = NULL;
	DejaDupBackend* _tmp5_;
	DejaDupBackend* _tmp6_;
	DejaDupBackendMicrosoft* _tmp7_;
	DejaDupBackendMicrosoft* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 193 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 195 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 195 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 195 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_GOOGLE (_tmp1_) ? ((DejaDupBackendGoogle*) _tmp1_) : NULL);
#line 195 "../libdeja/duplicity/DuplicityJob.vala"
	google_backend = _tmp2_;
#line 196 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = google_backend;
#line 196 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp3_ != NULL) {
#line 1573 "DuplicityJob.c"
		DejaDupBackendGoogle* _tmp4_;
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = google_backend;
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_fill_envp_from_google (self, _tmp4_, &_inner_error0_);
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
			g_propagate_error (error, _inner_error0_);
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
			_g_object_unref0 (google_backend);
#line 197 "../libdeja/duplicity/DuplicityJob.vala"
			return;
#line 1587 "DuplicityJob.c"
		}
	}
#line 199 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 199 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp6_ = _tmp5_;
#line 199 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp7_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_MICROSOFT (_tmp6_) ? ((DejaDupBackendMicrosoft*) _tmp6_) : NULL);
#line 199 "../libdeja/duplicity/DuplicityJob.vala"
	microsoft_backend = _tmp7_;
#line 200 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp8_ = microsoft_backend;
#line 200 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp8_ != NULL) {
#line 1602 "DuplicityJob.c"
		DejaDupBackendMicrosoft* _tmp9_;
#line 201 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp9_ = microsoft_backend;
#line 201 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_fill_envp_from_microsoft (self, _tmp9_);
#line 1608 "DuplicityJob.c"
	}
#line 193 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (microsoft_backend);
#line 193 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (google_backend);
#line 1614 "DuplicityJob.c"
}

static gchar*
duplicity_job_get_remote (DuplicityJob* self)
{
	DejaDupBackendFile* file_backend = NULL;
	DejaDupBackend* _tmp0_;
	DejaDupBackend* _tmp1_;
	DejaDupBackendFile* _tmp2_;
	DejaDupBackendFile* _tmp3_;
	DejaDupBackendGoogle* google_backend = NULL;
	DejaDupBackend* _tmp12_;
	DejaDupBackend* _tmp13_;
	DejaDupBackendGoogle* _tmp14_;
	DejaDupBackendGoogle* _tmp15_;
	DejaDupBackendMicrosoft* microsoft_backend = NULL;
	DejaDupBackend* _tmp21_;
	DejaDupBackend* _tmp22_;
	DejaDupBackendMicrosoft* _tmp23_;
	DejaDupBackendMicrosoft* _tmp24_;
	gchar* _tmp30_;
	gchar* result;
#line 204 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 206 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 206 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_FILE (_tmp1_) ? ((DejaDupBackendFile*) _tmp1_) : NULL);
#line 206 "../libdeja/duplicity/DuplicityJob.vala"
	file_backend = _tmp2_;
#line 207 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = file_backend;
#line 207 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp3_ != NULL) {
#line 1651 "DuplicityJob.c"
		GFile* file = NULL;
		DejaDupBackendFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
#line 208 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = file_backend;
#line 208 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = deja_dup_backend_file_get_file_from_settings (_tmp4_);
#line 208 "../libdeja/duplicity/DuplicityJob.vala"
		file = _tmp5_;
#line 209 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = file;
#line 209 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp6_ != NULL) {
#line 1666 "DuplicityJob.c"
			GFile* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp7_ = file;
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp8_ = g_file_get_uri (_tmp7_);
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp9_ = _tmp8_;
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp10_ = g_strconcat ("gio+", _tmp9_, NULL);
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp11_ = _tmp10_;
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_g_free0 (_tmp9_);
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			result = _tmp11_;
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_g_object_unref0 (file);
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			_g_object_unref0 (file_backend);
#line 210 "../libdeja/duplicity/DuplicityJob.vala"
			return result;
#line 1692 "DuplicityJob.c"
		}
#line 207 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (file);
#line 1696 "DuplicityJob.c"
	}
#line 214 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp12_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 214 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp13_ = _tmp12_;
#line 214 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp14_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_GOOGLE (_tmp13_) ? ((DejaDupBackendGoogle*) _tmp13_) : NULL);
#line 214 "../libdeja/duplicity/DuplicityJob.vala"
	google_backend = _tmp14_;
#line 215 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp15_ = google_backend;
#line 215 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp15_ != NULL) {
#line 1710 "DuplicityJob.c"
		DejaDupBackendGoogle* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp16_ = google_backend;
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp17_ = deja_dup_backend_google_get_folder (_tmp16_);
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp18_ = _tmp17_;
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp19_ = g_strdup_printf ("pydrive://google/%s", _tmp18_);
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp20_ = _tmp19_;
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp18_);
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp20_;
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (google_backend);
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (file_backend);
#line 217 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 1736 "DuplicityJob.c"
	}
#line 220 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp21_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 220 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp22_ = _tmp21_;
#line 220 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp23_ = _g_object_ref0 (DEJA_DUP_IS_BACKEND_MICROSOFT (_tmp22_) ? ((DejaDupBackendMicrosoft*) _tmp22_) : NULL);
#line 220 "../libdeja/duplicity/DuplicityJob.vala"
	microsoft_backend = _tmp23_;
#line 221 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp24_ = microsoft_backend;
#line 221 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp24_ != NULL) {
#line 1750 "DuplicityJob.c"
		DejaDupBackendMicrosoft* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp25_ = microsoft_backend;
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp26_ = deja_dup_backend_microsoft_get_folder (_tmp25_);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp27_ = _tmp26_;
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp28_ = g_strdup_printf ("onedrive://%s", _tmp27_);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp29_ = _tmp28_;
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp27_);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp29_;
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (microsoft_backend);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (google_backend);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (file_backend);
#line 222 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 1778 "DuplicityJob.c"
	}
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp30_ = g_strdup ("invalid://");
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	result = _tmp30_;
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (microsoft_backend);
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (google_backend);
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (file_backend);
#line 225 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 1792 "DuplicityJob.c"
}

static gchar*
duplicity_job_escape_duplicity_path (DuplicityJob* self,
                                     const gchar* path)
{
	gchar* rv = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 228 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 228 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 235 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = string_replace (path, "[", "[[]");
#line 235 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 235 "../libdeja/duplicity/DuplicityJob.vala"
	rv = _tmp0_;
#line 236 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = rv;
#line 236 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = string_replace (_tmp1_, "?", "[?]");
#line 236 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 236 "../libdeja/duplicity/DuplicityJob.vala"
	rv = _tmp2_;
#line 237 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = rv;
#line 237 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = string_replace (_tmp3_, "*", "[*]");
#line 237 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (rv);
#line 237 "../libdeja/duplicity/DuplicityJob.vala"
	rv = _tmp4_;
#line 238 "../libdeja/duplicity/DuplicityJob.vala"
	result = rv;
#line 238 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 1836 "DuplicityJob.c"
}

static gchar*
duplicity_job_prefix_local (DuplicityJob* self,
                            const gchar* path)
{
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 241 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 241 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 243 "../libdeja/duplicity/DuplicityJob.vala"
	if (g_strcmp0 (path, "/") == 0) {
#line 1856 "DuplicityJob.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
		gchar* _tmp2_;
#line 244 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 244 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = _tmp0_;
#line 244 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = g_file_get_path (_tmp1_);
#line 244 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp2_;
#line 244 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 1870 "DuplicityJob.c"
	}
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = _tmp3_;
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp6_ = _tmp5_;
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp7_ = g_build_filename (_tmp6_, path, NULL);
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp8_ = _tmp7_;
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_tmp6_);
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	result = _tmp8_;
#line 245 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 1890 "DuplicityJob.c"
}

static void
duplicity_job_process_include_excludes (DuplicityJob* self)
{
	GList* _tmp0_;
	GList* _tmp10_;
	GList* excludes2 = NULL;
	GList* _tmp16_;
	GList* _tmp17_;
	GList* _tmp18_;
	GList* _tmp42_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GList* _tmp55_;
	GList* _tmp56_;
#line 248 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 257 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_expand_links_in_list (&((DejaDupToolJob*) self)->includes, TRUE);
#line 258 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_expand_links_in_list (&((DejaDupToolJob*) self)->includes_priority, TRUE);
#line 259 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_expand_links_in_list (&((DejaDupToolJob*) self)->excludes, FALSE);
#line 264 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJob*) self)->includes = g_list_sort (((DejaDupToolJob*) self)->includes, (GCompareFunc) duplicity_job_cmp_prefix);
#line 265 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJob*) self)->excludes = g_list_sort (((DejaDupToolJob*) self)->excludes, (GCompareFunc) duplicity_job_cmp_prefix);
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = ((DejaDupToolJob*) self)->includes_priority;
#line 1922 "DuplicityJob.c"
	{
		GList* i_collection = NULL;
		GList* i_it = NULL;
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
		i_collection = _tmp0_;
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 1930 "DuplicityJob.c"
			GFile* _tmp1_;
			GFile* i = NULL;
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp1_ = _g_object_ref0 ((GFile*) i_it->data);
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
			i = _tmp1_;
#line 1937 "DuplicityJob.c"
			{
				GFile* _tmp2_;
				gchar* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = i;
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = g_file_get_path (_tmp2_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp4_ = _tmp3_;
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp5_ = duplicity_job_prefix_local (self, _tmp4_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp6_ = _tmp5_;
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp7_ = duplicity_job_escape_duplicity_path (self, _tmp6_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp8_ = _tmp7_;
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp9_ = g_strconcat ("--include=", _tmp8_, NULL);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp9_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp8_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp6_);
#line 272 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp4_);
#line 271 "../libdeja/duplicity/DuplicityJob.vala"
				_g_object_unref0 (i);
#line 1973 "DuplicityJob.c"
			}
		}
	}
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp10_ = ((DejaDupToolJob*) self)->exclude_regexps;
#line 1979 "DuplicityJob.c"
	{
		GList* r_collection = NULL;
		GList* r_it = NULL;
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
		r_collection = _tmp10_;
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
		for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 1987 "DuplicityJob.c"
			gchar* _tmp11_;
			gchar* r = NULL;
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp11_ = g_strdup ((const gchar*) r_it->data);
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
			r = _tmp11_;
#line 1994 "DuplicityJob.c"
			{
				const gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp12_ = r;
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp13_ = duplicity_job_prefix_local (self, _tmp12_);
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp14_ = _tmp13_;
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp15_ = g_strconcat ("--exclude=", _tmp14_, NULL);
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp15_);
#line 280 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp14_);
#line 279 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (r);
#line 2014 "DuplicityJob.c"
			}
		}
	}
#line 283 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp16_ = ((DejaDupToolJob*) self)->excludes;
#line 283 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp17_ = g_list_copy (_tmp16_);
#line 283 "../libdeja/duplicity/DuplicityJob.vala"
	excludes2 = _tmp17_;
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp18_ = ((DejaDupToolJob*) self)->includes;
#line 2026 "DuplicityJob.c"
	{
		GList* i_collection = NULL;
		GList* i_it = NULL;
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
		i_collection = _tmp18_;
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
		for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 2034 "DuplicityJob.c"
			GFile* _tmp19_;
			GFile* i = NULL;
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp19_ = _g_object_ref0 ((GFile*) i_it->data);
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
			i = _tmp19_;
#line 2041 "DuplicityJob.c"
			{
				GList* _tmp20_;
				GList* _tmp21_;
				GFile* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp20_ = excludes2;
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp21_ = g_list_copy (_tmp20_);
#line 2057 "DuplicityJob.c"
				{
					GList* e_collection = NULL;
					GList* e_it = NULL;
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
					e_collection = _tmp21_;
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
					for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 2065 "DuplicityJob.c"
						GFile* _tmp22_;
						GFile* e = NULL;
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp22_ = _g_object_ref0 ((GFile*) e_it->data);
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
						e = _tmp22_;
#line 2072 "DuplicityJob.c"
						{
							GFile* _tmp23_;
							GFile* _tmp24_;
#line 286 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp23_ = e;
#line 286 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp24_ = i;
#line 286 "../libdeja/duplicity/DuplicityJob.vala"
							if (g_file_has_prefix (_tmp23_, _tmp24_)) {
#line 2082 "DuplicityJob.c"
								GFile* _tmp25_;
								gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
								gchar* _tmp29_;
								gchar* _tmp30_;
								gchar* _tmp31_;
								gchar* _tmp32_;
								GFile* _tmp33_;
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp25_ = e;
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp26_ = g_file_get_path (_tmp25_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp27_ = _tmp26_;
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp28_ = duplicity_job_prefix_local (self, _tmp27_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp29_ = _tmp28_;
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp30_ = duplicity_job_escape_duplicity_path (self, _tmp29_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp31_ = _tmp30_;
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp32_ = g_strconcat ("--exclude=", _tmp31_, NULL);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp32_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp31_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp29_);
#line 287 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp27_);
#line 288 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp33_ = e;
#line 288 "../libdeja/duplicity/DuplicityJob.vala"
								excludes2 = g_list_remove (excludes2, _tmp33_);
#line 2120 "DuplicityJob.c"
							}
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
							_g_object_unref0 (e);
#line 2124 "DuplicityJob.c"
						}
					}
#line 285 "../libdeja/duplicity/DuplicityJob.vala"
					(e_collection == NULL) ? NULL : (e_collection = (g_list_free (e_collection), NULL));
#line 2129 "DuplicityJob.c"
				}
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp34_ = i;
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp35_ = g_file_get_path (_tmp34_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp36_ = _tmp35_;
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp37_ = duplicity_job_prefix_local (self, _tmp36_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp38_ = _tmp37_;
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp39_ = duplicity_job_escape_duplicity_path (self, _tmp38_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp40_ = _tmp39_;
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp41_ = g_strconcat ("--include=", _tmp40_, NULL);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp41_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp40_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp38_);
#line 291 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp36_);
#line 284 "../libdeja/duplicity/DuplicityJob.vala"
				_g_object_unref0 (i);
#line 2157 "DuplicityJob.c"
			}
		}
	}
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp42_ = excludes2;
#line 2163 "DuplicityJob.c"
	{
		GList* e_collection = NULL;
		GList* e_it = NULL;
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
		e_collection = _tmp42_;
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
		for (e_it = e_collection; e_it != NULL; e_it = e_it->next) {
#line 2171 "DuplicityJob.c"
			GFile* _tmp43_;
			GFile* e = NULL;
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp43_ = _g_object_ref0 ((GFile*) e_it->data);
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
			e = _tmp43_;
#line 2178 "DuplicityJob.c"
			{
				GFile* _tmp44_;
				gchar* _tmp45_;
				gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp44_ = e;
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp45_ = g_file_get_path (_tmp44_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp46_ = _tmp45_;
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp47_ = duplicity_job_prefix_local (self, _tmp46_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp48_ = _tmp47_;
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp49_ = duplicity_job_escape_duplicity_path (self, _tmp48_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp50_ = _tmp49_;
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp51_ = g_strconcat ("--exclude=", _tmp50_, NULL);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp51_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp50_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp48_);
#line 294 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_tmp46_);
#line 293 "../libdeja/duplicity/DuplicityJob.vala"
				_g_object_unref0 (e);
#line 2214 "DuplicityJob.c"
			}
		}
	}
#line 297 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp52_ = g_strdup ("--exclude=**");
#line 297 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp52_);
#line 298 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp53_ = g_strdup ("--exclude-if-present=CACHEDIR.TAG");
#line 298 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp53_);
#line 299 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp54_ = g_strdup ("--exclude-if-present=.deja-dup-ignore");
#line 299 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp54_);
#line 303 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp55_ = ((DejaDupToolJob*) self)->includes_priority;
#line 303 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp56_ = g_list_copy_deep (_tmp55_, (GCopyFunc) g_object_ref, NULL);
#line 303 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJob*) self)->includes = g_list_concat (((DejaDupToolJob*) self)->includes, _tmp56_);
#line 248 "../libdeja/duplicity/DuplicityJob.vala"
	(excludes2 == NULL) ? NULL : (excludes2 = (g_list_free (excludes2), NULL));
#line 2238 "DuplicityJob.c"
}

static void
duplicity_job_real_cancel (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DejaDupToolJobMode prev_mode = 0;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 306 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 307 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 307 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 307 "../libdeja/duplicity/DuplicityJob.vala"
	prev_mode = _tmp1_;
#line 308 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 310 "../libdeja/duplicity/DuplicityJob.vala"
	if (prev_mode == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 2261 "DuplicityJob.c"
		DuplicityJobState _tmp3_;
#line 310 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = self->priv->_state;
#line 310 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = _tmp3_ == DUPLICITY_JOB_STATE_NORMAL;
#line 2267 "DuplicityJob.c"
	} else {
#line 310 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = FALSE;
#line 2271 "DuplicityJob.c"
	}
#line 310 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp2_) {
#line 311 "../libdeja/duplicity/DuplicityJob.vala"
		if (duplicity_job_cleanup (self)) {
#line 312 "../libdeja/duplicity/DuplicityJob.vala"
			return;
#line 2279 "DuplicityJob.c"
		}
	}
#line 315 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_cancel_inst (self);
#line 2284 "DuplicityJob.c"
}

static void
duplicity_job_real_stop (DejaDupToolJob* base)
{
	DuplicityJob * self;
#line 318 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 320 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_was_stopped (self, TRUE);
#line 321 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 322 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_cancel_inst (self);
#line 2299 "DuplicityJob.c"
}

static void
duplicity_job_real_pause (DejaDupToolJob* base,
                          const gchar* reason)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
#line 325 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 327 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 327 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 2314 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
#line 328 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 328 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_instance_pause (_tmp1_);
#line 329 "../libdeja/duplicity/DuplicityJob.vala"
		if (reason != NULL) {
#line 330 "../libdeja/duplicity/DuplicityJob.vala"
			duplicity_job_set_status (self, reason, FALSE);
#line 2324 "DuplicityJob.c"
		}
	}
}

static void
duplicity_job_real_resume (DejaDupToolJob* base)
{
	DuplicityJob * self;
	DuplicityInstance* _tmp0_;
#line 334 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) base;
#line 336 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 336 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 2340 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
#line 337 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 337 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_instance_resume (_tmp1_);
#line 338 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_saved_status (self);
#line 2348 "DuplicityJob.c"
	}
}

static void
duplicity_job_cancel_inst (DuplicityJob* self)
{
#line 342 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 344 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 345 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_handle_done (self, NULL, FALSE, TRUE);
#line 2361 "DuplicityJob.c"
}

static gboolean
duplicity_job_restart (DuplicityJob* self)
{
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	GList* extra_argv = NULL;
	gchar* action_desc = NULL;
	GFile* custom_local = NULL;
	DejaDupToolJobMode _tmp2_;
	const gchar* _tmp71_;
	const gchar* _tmp75_;
	GList* _tmp76_;
	GFile* _tmp77_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 348 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 350 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_NORMAL);
#line 352 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 352 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 352 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp1_ == DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 353 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 353 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 2393 "DuplicityJob.c"
	}
#line 355 "../libdeja/duplicity/DuplicityJob.vala"
	extra_argv = NULL;
#line 356 "../libdeja/duplicity/DuplicityJob.vala"
	action_desc = NULL;
#line 357 "../libdeja/duplicity/DuplicityJob.vala"
	custom_local = NULL;
#line 359 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = self->priv->_original_mode;
#line 359 "../libdeja/duplicity/DuplicityJob.vala"
	switch (_tmp2_) {
#line 359 "../libdeja/duplicity/DuplicityJob.vala"
		case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
#line 2407 "DuplicityJob.c"
		{
#line 361 "../libdeja/duplicity/DuplicityJob.vala"
			deja_dup_tool_job_set_tag ((DejaDupToolJob*) self, "now");
#line 365 "../libdeja/duplicity/DuplicityJob.vala"
			if (!self->priv->checked_collection_info) {
#line 2413 "DuplicityJob.c"
				gchar* _tmp3_;
#line 366 "../libdeja/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
#line 367 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
#line 368 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = g_strdup (_ ("Preparing…"));
#line 368 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (action_desc);
#line 368 "../libdeja/duplicity/DuplicityJob.vala"
				action_desc = _tmp3_;
#line 2425 "DuplicityJob.c"
			} else {
				gboolean _tmp4_ = FALSE;
#line 370 "../libdeja/duplicity/DuplicityJob.vala"
				if (!self->priv->reported_full_backups) {
#line 370 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp4_ = self->priv->got_collection_info;
#line 2432 "DuplicityJob.c"
				} else {
#line 370 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp4_ = FALSE;
#line 2436 "DuplicityJob.c"
				}
#line 370 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp4_) {
#line 371 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_report_full_backups (self, NULL, NULL);
#line 372 "../libdeja/duplicity/DuplicityJob.vala"
					result = TRUE;
#line 372 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (custom_local);
#line 372 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (action_desc);
#line 372 "../libdeja/duplicity/DuplicityJob.vala"
					(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 372 "../libdeja/duplicity/DuplicityJob.vala"
					return result;
#line 2452 "DuplicityJob.c"
				} else {
					gboolean _tmp5_ = FALSE;
					DejaDupToolJobFlags _tmp6_;
					DejaDupToolJobFlags _tmp7_;
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp6_ = deja_dup_tool_job_get_flags ((DejaDupToolJob*) self);
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp7_ = _tmp6_;
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
					if ((_tmp7_ & DEJA_DUP_TOOL_JOB_FLAGS_NO_PROGRESS) == 0) {
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp5_ = !self->priv->has_progress_total;
#line 2465 "DuplicityJob.c"
					} else {
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp5_ = FALSE;
#line 2469 "DuplicityJob.c"
					}
#line 377 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp5_) {
#line 2473 "DuplicityJob.c"
						gchar* _tmp8_;
						gchar* _tmp9_;
#line 378 "../libdeja/duplicity/DuplicityJob.vala"
						duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DRY_RUN);
#line 379 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp8_ = g_strdup (_ ("Preparing…"));
#line 379 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (action_desc);
#line 379 "../libdeja/duplicity/DuplicityJob.vala"
						action_desc = _tmp8_;
#line 380 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp9_ = g_strdup ("--dry-run");
#line 380 "../libdeja/duplicity/DuplicityJob.vala"
						extra_argv = g_list_append (extra_argv, _tmp9_);
#line 2488 "DuplicityJob.c"
					} else {
#line 382 "../libdeja/duplicity/DuplicityJob.vala"
						if (!self->priv->checked_backup_space) {
#line 383 "../libdeja/duplicity/DuplicityJob.vala"
							duplicity_job_check_backup_space (self, NULL, NULL);
#line 384 "../libdeja/duplicity/DuplicityJob.vala"
							result = TRUE;
#line 384 "../libdeja/duplicity/DuplicityJob.vala"
							_g_object_unref0 (custom_local);
#line 384 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (action_desc);
#line 384 "../libdeja/duplicity/DuplicityJob.vala"
							(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 384 "../libdeja/duplicity/DuplicityJob.vala"
							return result;
#line 2504 "DuplicityJob.c"
						} else {
#line 387 "../libdeja/duplicity/DuplicityJob.vala"
							if (self->priv->has_progress_total) {
#line 388 "../libdeja/duplicity/DuplicityJob.vala"
								g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
#line 2510 "DuplicityJob.c"
							}
#line 389 "../libdeja/duplicity/DuplicityJob.vala"
							if (self->priv->is_full_backup) {
#line 2514 "DuplicityJob.c"
								{
									GRegex* _tmp10_ = NULL;
									GRegex* _tmp11_;
#line 399 "../libdeja/duplicity/DuplicityJob.vala"
									_tmp11_ = g_regex_new ("^duplicity-full\\..*\\.manifest$", 0, 0, &_inner_error0_);
#line 399 "../libdeja/duplicity/DuplicityJob.vala"
									_tmp10_ = _tmp11_;
#line 399 "../libdeja/duplicity/DuplicityJob.vala"
									if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2524 "DuplicityJob.c"
										goto __catch0_g_error;
									}
#line 399 "../libdeja/duplicity/DuplicityJob.vala"
									duplicity_job_delete_cache (self, _tmp10_);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									_g_regex_unref0 (_tmp10_);
#line 2531 "DuplicityJob.c"
								}
								goto __finally0;
								__catch0_g_error:
								{
									GError* e = NULL;
									GError* _tmp12_;
									const gchar* _tmp13_;
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									e = _inner_error0_;
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									_inner_error0_ = NULL;
#line 402 "../libdeja/duplicity/DuplicityJob.vala"
									_tmp12_ = e;
#line 402 "../libdeja/duplicity/DuplicityJob.vala"
									_tmp13_ = _tmp12_->message;
#line 402 "../libdeja/duplicity/DuplicityJob.vala"
									g_warning ("DuplicityJob.vala:402: %s\n", _tmp13_);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									_g_error_free0 (e);
#line 2551 "DuplicityJob.c"
								}
								__finally0:
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
								if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2556 "DuplicityJob.c"
									gboolean _tmp14_ = FALSE;
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									_g_object_unref0 (custom_local);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									_g_free0 (action_desc);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									g_clear_error (&_inner_error0_);
#line 398 "../libdeja/duplicity/DuplicityJob.vala"
									return _tmp14_;
#line 2570 "DuplicityJob.c"
								}
							}
						}
					}
				}
			}
#line 407 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 2579 "DuplicityJob.c"
		}
#line 359 "../libdeja/duplicity/DuplicityJob.vala"
		case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
#line 2583 "DuplicityJob.c"
		{
#line 412 "../libdeja/duplicity/DuplicityJob.vala"
			if (!self->priv->checked_collection_info) {
#line 2587 "DuplicityJob.c"
				gchar* _tmp15_;
#line 413 "../libdeja/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_STATUS);
#line 414 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_set_state (self, DUPLICITY_JOB_STATE_STATUS);
#line 415 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp15_ = g_strdup (_ ("Preparing…"));
#line 415 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (action_desc);
#line 415 "../libdeja/duplicity/DuplicityJob.vala"
				action_desc = _tmp15_;
#line 2599 "DuplicityJob.c"
			} else {
				gboolean _tmp16_ = FALSE;
				DejaDupFileTree* _tmp17_;
				DejaDupFileTree* _tmp18_;
				GList* _tmp37_;
				GList* _tmp38_;
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp17_ = deja_dup_tool_job_get_tree ((DejaDupToolJob*) self);
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp18_ = _tmp17_;
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp18_ != NULL) {
#line 2612 "DuplicityJob.c"
					DejaDupFileTree* _tmp19_;
					DejaDupFileTree* _tmp20_;
					const gchar* _tmp21_;
					const gchar* _tmp22_;
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp19_ = deja_dup_tool_job_get_tree ((DejaDupToolJob*) self);
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp20_ = _tmp19_;
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp21_ = deja_dup_file_tree_get_old_home (_tmp20_);
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp22_ = _tmp21_;
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp16_ = _tmp22_ != NULL;
#line 2627 "DuplicityJob.c"
				} else {
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp16_ = FALSE;
#line 2631 "DuplicityJob.c"
				}
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp16_) {
#line 2635 "DuplicityJob.c"
					GFile* old_home = NULL;
					DejaDupFileTree* _tmp23_;
					DejaDupFileTree* _tmp24_;
					const gchar* _tmp25_;
					const gchar* _tmp26_;
					GFile* _tmp27_;
					GFile* new_home = NULL;
					const gchar* _tmp28_;
					GFile* _tmp29_;
					gchar* _tmp30_;
					GFile* _tmp31_;
					GFile* _tmp32_;
					gchar* _tmp33_;
					GFile* _tmp34_;
					GFile* _tmp35_;
					gchar* _tmp36_;
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp23_ = deja_dup_tool_job_get_tree ((DejaDupToolJob*) self);
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp24_ = _tmp23_;
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp25_ = deja_dup_file_tree_get_old_home (_tmp24_);
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp26_ = _tmp25_;
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp27_ = g_file_new_for_path (_tmp26_);
#line 421 "../libdeja/duplicity/DuplicityJob.vala"
					old_home = _tmp27_;
#line 422 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp28_ = g_get_home_dir ();
#line 422 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp29_ = g_file_new_for_path (_tmp28_);
#line 422 "../libdeja/duplicity/DuplicityJob.vala"
					new_home = _tmp29_;
#line 423 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp30_ = g_strdup ("--rename");
#line 423 "../libdeja/duplicity/DuplicityJob.vala"
					extra_argv = g_list_append (extra_argv, _tmp30_);
#line 424 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp31_ = duplicity_job_slash;
#line 424 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp32_ = old_home;
#line 424 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp33_ = g_file_get_relative_path (_tmp31_, _tmp32_);
#line 424 "../libdeja/duplicity/DuplicityJob.vala"
					extra_argv = g_list_append (extra_argv, _tmp33_);
#line 425 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp34_ = duplicity_job_slash;
#line 425 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp35_ = new_home;
#line 425 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp36_ = g_file_get_relative_path (_tmp34_, _tmp35_);
#line 425 "../libdeja/duplicity/DuplicityJob.vala"
					extra_argv = g_list_append (extra_argv, _tmp36_);
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (new_home);
#line 420 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (old_home);
#line 2694 "DuplicityJob.c"
				}
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp37_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp38_ = _tmp37_;
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp38_ != NULL) {
#line 2702 "DuplicityJob.c"
					GFile* local_file = NULL;
					GList* _tmp39_;
					GList* _tmp40_;
					gconstpointer _tmp41_;
					GFile* _tmp42_;
					GFile* _tmp49_;
					GFile* _tmp50_;
					GFile* target_file = NULL;
					GList* _tmp51_;
					GList* _tmp52_;
					gconstpointer _tmp53_;
					GFile* _tmp54_;
					DejaDupFileTree* _tmp55_;
					DejaDupFileTree* _tmp56_;
					gchar* rel_file_path = NULL;
					GFile* _tmp66_;
					GFile* _tmp67_;
					gchar* _tmp68_;
					const gchar* _tmp69_;
					gchar* _tmp70_;
#line 433 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp39_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 433 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp40_ = _tmp39_;
#line 433 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp41_ = _tmp40_->data;
#line 433 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp42_ = duplicity_job_make_local_rel_path (self, (GFile*) _tmp41_);
#line 433 "../libdeja/duplicity/DuplicityJob.vala"
					local_file = _tmp42_;
#line 2733 "DuplicityJob.c"
					{
						GFile* _tmp43_;
						GFile* _tmp44_;
						GFile* _tmp45_;
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp43_ = local_file;
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp44_ = g_file_get_parent (_tmp43_);
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp45_ = _tmp44_;
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						g_file_make_directory_with_parents (_tmp45_, NULL, &_inner_error0_);
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (_tmp45_);
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 436 "../libdeja/duplicity/DuplicityJob.vala"
							if (g_error_matches (_inner_error0_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 2752 "DuplicityJob.c"
								goto __catch1_g_io_error_exists;
							}
							goto __catch1_g_error;
						}
					}
					goto __finally1;
					__catch1_g_io_error_exists:
					{
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						g_clear_error (&_inner_error0_);
#line 2763 "DuplicityJob.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
						GError* e = NULL;
						GError* _tmp46_;
						const gchar* _tmp47_;
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						e = _inner_error0_;
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						_inner_error0_ = NULL;
#line 442 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp46_ = e;
#line 442 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp47_ = _tmp46_->message;
#line 442 "../libdeja/duplicity/DuplicityJob.vala"
						duplicity_job_show_error (self, _tmp47_, NULL);
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						result = FALSE;
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						_g_error_free0 (e);
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (local_file);
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (custom_local);
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (action_desc);
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 443 "../libdeja/duplicity/DuplicityJob.vala"
						return result;
#line 2795 "DuplicityJob.c"
					}
					__finally1:
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2800 "DuplicityJob.c"
						gboolean _tmp48_ = FALSE;
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (local_file);
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (custom_local);
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (action_desc);
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						g_clear_error (&_inner_error0_);
#line 434 "../libdeja/duplicity/DuplicityJob.vala"
						return _tmp48_;
#line 2816 "DuplicityJob.c"
					}
#line 445 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp49_ = local_file;
#line 445 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp50_ = _g_object_ref0 (_tmp49_);
#line 445 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (custom_local);
#line 445 "../libdeja/duplicity/DuplicityJob.vala"
					custom_local = _tmp50_;
#line 447 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp51_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 447 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp52_ = _tmp51_;
#line 447 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp53_ = _tmp52_->data;
#line 447 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp54_ = _g_object_ref0 ((GFile*) _tmp53_);
#line 447 "../libdeja/duplicity/DuplicityJob.vala"
					target_file = _tmp54_;
#line 448 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp55_ = deja_dup_tool_job_get_tree ((DejaDupToolJob*) self);
#line 448 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp56_ = _tmp55_;
#line 448 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp56_ != NULL) {
#line 2842 "DuplicityJob.c"
						gchar* translated_path = NULL;
						DejaDupFileTree* _tmp57_;
						DejaDupFileTree* _tmp58_;
						GFile* _tmp59_;
						gchar* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						const gchar* _tmp64_;
						GFile* _tmp65_;
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp57_ = deja_dup_tool_job_get_tree ((DejaDupToolJob*) self);
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp58_ = _tmp57_;
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp59_ = target_file;
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp60_ = g_file_get_path (_tmp59_);
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp61_ = _tmp60_;
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp62_ = deja_dup_file_tree_original_path (_tmp58_, _tmp61_);
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp63_ = _tmp62_;
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (_tmp61_);
#line 449 "../libdeja/duplicity/DuplicityJob.vala"
						translated_path = _tmp63_;
#line 450 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp64_ = translated_path;
#line 450 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp65_ = g_file_new_for_path (_tmp64_);
#line 450 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (target_file);
#line 450 "../libdeja/duplicity/DuplicityJob.vala"
						target_file = _tmp65_;
#line 448 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (translated_path);
#line 2881 "DuplicityJob.c"
					}
#line 452 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp66_ = duplicity_job_slash;
#line 452 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp67_ = target_file;
#line 452 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp68_ = g_file_get_relative_path (_tmp66_, _tmp67_);
#line 452 "../libdeja/duplicity/DuplicityJob.vala"
					rel_file_path = _tmp68_;
#line 453 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp69_ = rel_file_path;
#line 453 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp70_ = g_strdup_printf ("--file-to-restore=%s", _tmp69_);
#line 453 "../libdeja/duplicity/DuplicityJob.vala"
					extra_argv = g_list_append (extra_argv, _tmp70_);
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (rel_file_path);
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (target_file);
#line 428 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (local_file);
#line 2903 "DuplicityJob.c"
				}
#line 456 "../libdeja/duplicity/DuplicityJob.vala"
				g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", (gdouble) 0.f);
#line 2907 "DuplicityJob.c"
			}
#line 458 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 2911 "DuplicityJob.c"
		}
		default:
		{
#line 461 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 2917 "DuplicityJob.c"
		}
	}
#line 466 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp71_ = action_desc;
#line 466 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp71_ == NULL) {
#line 2924 "DuplicityJob.c"
		DejaDupToolJobMode _tmp72_;
		DejaDupToolJobMode _tmp73_;
		gchar* _tmp74_;
#line 467 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp72_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 467 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp73_ = _tmp72_;
#line 467 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp74_ = deja_dup_operation_mode_to_string (_tmp73_);
#line 467 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (action_desc);
#line 467 "../libdeja/duplicity/DuplicityJob.vala"
		action_desc = _tmp74_;
#line 2938 "DuplicityJob.c"
	}
#line 468 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp75_ = action_desc;
#line 468 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _tmp75_, TRUE);
#line 470 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp76_ = extra_argv;
#line 470 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp77_ = custom_local;
#line 470 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, _tmp76_, NULL, NULL, _tmp77_);
#line 471 "../libdeja/duplicity/DuplicityJob.vala"
	result = TRUE;
#line 471 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (custom_local);
#line 471 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (action_desc);
#line 471 "../libdeja/duplicity/DuplicityJob.vala"
	(extra_argv == NULL) ? NULL : (extra_argv = (_g_list_free__g_free0_ (extra_argv), NULL));
#line 471 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 2960 "DuplicityJob.c"
}

static GFile*
duplicity_job_make_local_rel_path (DuplicityJob* self,
                                   GFile* file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gboolean _tmp4_;
	GFile* result;
#line 474 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 474 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = _tmp3_ == NULL;
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp3_);
#line 476 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp4_) {
#line 2991 "DuplicityJob.c"
		GFile* _tmp5_;
#line 477 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = _g_object_ref0 (file);
#line 477 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp5_;
#line 477 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 2999 "DuplicityJob.c"
	} else {
		GFile* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = _tmp6_;
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp8_ = g_file_get_basename (file);
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp9_ = _tmp8_;
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp10_ = g_file_get_child (_tmp7_, _tmp9_);
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp11_ = _tmp10_;
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_tmp9_);
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp11_;
#line 479 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 3025 "DuplicityJob.c"
	}
}

static void
duplicity_job_report_full_backups_data_free (gpointer _data)
{
	DuplicityJobReportFullBackupsData* _data_;
	_data_ = _data;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobReportFullBackupsData, _data_);
#line 3038 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups (DuplicityJob* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	DuplicityJobReportFullBackupsData* _data_;
	DuplicityJob* _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobReportFullBackupsData);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_report_full_backups_data_free);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_report_full_backups_co (_data_);
#line 3062 "DuplicityJob.c"
}

static void
duplicity_job_report_full_backups_finish (DuplicityJob* self,
                                          GAsyncResult* _res_)
{
	DuplicityJobReportFullBackupsData* _data_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3072 "DuplicityJob.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 3080 "DuplicityJob.c"
}

static gboolean
duplicity_job_report_full_backups_co (DuplicityJobReportFullBackupsData* _data_)
{
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
		case 0:
#line 3090 "DuplicityJob.c"
		goto _state_0;
		default:
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 3095 "DuplicityJob.c"
	}
	_state_0:
#line 484 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->full_backup = NULL;
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = _data_->self->priv->collection_info;
#line 3102 "DuplicityJob.c"
	{
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->info_collection = _data_->_tmp0_;
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
		for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp1_ = *((DuplicityJobDateInfo*) _data_->info_it->data);
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
			memset (&_data_->_tmp2_, 0, sizeof (DuplicityJobDateInfo));
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
			duplicity_job_date_info_copy (&_data_->_tmp1_, &_data_->_tmp2_);
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->info = _data_->_tmp2_;
#line 3116 "DuplicityJob.c"
			{
#line 486 "../libdeja/duplicity/DuplicityJob.vala"
				_data_->_tmp3_ = _data_->info;
#line 486 "../libdeja/duplicity/DuplicityJob.vala"
				if (_data_->_tmp3_.full) {
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->_tmp4_ = _data_->info;
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->_tmp5_ = _data_->_tmp4_.time;
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->_tmp6_ = _g_date_time_ref0 (_data_->_tmp5_);
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
					_g_date_time_unref0 (_data_->full_backup);
#line 487 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->full_backup = _data_->_tmp6_;
#line 3132 "DuplicityJob.c"
				}
#line 485 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_date_info_destroy (&_data_->info);
#line 3136 "DuplicityJob.c"
			}
		}
	}
#line 489 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp7_ = _data_->full_backup;
#line 489 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->first_backup = _data_->_tmp7_ == NULL;
#line 491 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self->priv->reported_full_backups = TRUE;
#line 495 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp8_ = deja_dup_get_full_backup_threshold_date ();
#line 495 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->threshold = _data_->_tmp8_;
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp10_ = _data_->full_backup;
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp10_ == NULL) {
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = TRUE;
#line 3156 "DuplicityJob.c"
	} else {
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp11_ = _data_->threshold;
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp12_ = _data_->full_backup;
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = g_date_time_compare (_data_->_tmp11_, _data_->_tmp12_) > 0;
#line 3164 "DuplicityJob.c"
	}
#line 496 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp9_) {
#line 497 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->self->priv->is_full_backup = TRUE;
#line 498 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "is-full", _data_->first_backup);
#line 3172 "DuplicityJob.c"
	}
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp14_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) _data_->self);
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp15_ != DEJA_DUP_TOOL_JOB_MODE_INVALID) {
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp13_ = !duplicity_job_restart (_data_->self);
#line 3182 "DuplicityJob.c"
	} else {
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp13_ = FALSE;
#line 3186 "DuplicityJob.c"
	}
#line 501 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp13_) {
#line 502 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 3192 "DuplicityJob.c"
	}
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	_g_date_time_unref0 (_data_->threshold);
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	_g_date_time_unref0 (_data_->full_backup);
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3206 "DuplicityJob.c"
		}
	}
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 482 "../libdeja/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3213 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_data_free (gpointer _data)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	_data_ = _data;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_data_->self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_slice_free (DuplicityJobCheckBackupSpaceData, _data_);
#line 3225 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space (DuplicityJob* self,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
	DuplicityJob* _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_slice_new0 (DuplicityJobCheckBackupSpaceData);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_set_task_data (_data_->_async_result, _data_, duplicity_job_check_backup_space_data_free);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self = _tmp0_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_check_backup_space_co (_data_);
#line 3249 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_finish (DuplicityJob* self,
                                         GAsyncResult* _res_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3259 "DuplicityJob.c"
}

static void
duplicity_job_check_backup_space_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	DuplicityJobCheckBackupSpaceData* _data_;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_ = _user_data_;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_source_object_ = source_object;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_res_ = _res_;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_check_backup_space_co (_data_);
#line 3276 "DuplicityJob.c"
}

static gboolean
duplicity_job_check_backup_space_co (DuplicityJobCheckBackupSpaceData* _data_)
{
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	switch (_data_->_state_) {
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
		case 0:
#line 3286 "DuplicityJob.c"
		goto _state_0;
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
		case 1:
#line 3290 "DuplicityJob.c"
		goto _state_1;
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
		case 2:
#line 3294 "DuplicityJob.c"
		goto _state_2;
		default:
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
		g_assert_not_reached ();
#line 3299 "DuplicityJob.c"
	}
	_state_0:
#line 508 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->self->priv->checked_backup_space = TRUE;
#line 510 "../libdeja/duplicity/DuplicityJob.vala"
	if (!_data_->self->priv->has_progress_total) {
#line 511 "../libdeja/duplicity/DuplicityJob.vala"
		if (!duplicity_job_restart (_data_->self)) {
#line 512 "../libdeja/duplicity/DuplicityJob.vala"
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 3310 "DuplicityJob.c"
		}
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3320 "DuplicityJob.c"
			}
		}
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 513 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 3327 "DuplicityJob.c"
	}
#line 516 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp0_ = g_format_size_full (_data_->self->priv->progress_total, G_FORMAT_SIZE_DEFAULT);
#line 516 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->formatted_progress_total = _data_->_tmp0_;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp1_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_state_ = 1;
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_backend_get_space (_data_->_tmp2_, TRUE, duplicity_job_check_backup_space_ready, _data_);
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3343 "DuplicityJob.c"
	_state_1:
#line 517 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->free = deja_dup_backend_get_space_finish (_data_->_tmp2_, _data_->_res_);
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) _data_->self);
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->_state_ = 2;
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_backend_get_space (_data_->_tmp4_, FALSE, duplicity_job_check_backup_space_ready, _data_);
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3357 "DuplicityJob.c"
	_state_2:
#line 518 "../libdeja/duplicity/DuplicityJob.vala"
	_data_->total = deja_dup_backend_get_space_finish (_data_->_tmp4_, _data_->_res_);
#line 521 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->free != DEJA_DUP_BACKEND_INFINITE_SPACE) {
#line 521 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp5_ = _data_->free > _data_->total;
#line 3365 "DuplicityJob.c"
	} else {
#line 521 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp5_ = FALSE;
#line 3369 "DuplicityJob.c"
	}
#line 521 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_tmp5_) {
#line 522 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->total = _data_->free;
#line 3375 "DuplicityJob.c"
	}
#line 523 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->total < _data_->self->priv->progress_total) {
#line 525 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp6_ = g_strdup (_ ("Backup location is too small. Try using one with at least %s."));
#line 525 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->msg = _data_->_tmp6_;
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp7_ = _data_->msg;
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp8_ = _data_->formatted_progress_total;
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp9_ = g_strdup_printf (_data_->_tmp7_, _data_->_tmp8_);
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (_data_->self, _data_->_tmp10_, NULL);
#line 526 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->_tmp10_);
#line 527 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->msg);
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (_data_->formatted_progress_total);
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->_state_ != 0) {
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3409 "DuplicityJob.c"
			}
		}
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_unref (_data_->_async_result);
#line 528 "../libdeja/duplicity/DuplicityJob.vala"
		return FALSE;
#line 3416 "DuplicityJob.c"
	}
#line 531 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->free < _data_->self->priv->progress_total) {
#line 532 "../libdeja/duplicity/DuplicityJob.vala"
		if (_data_->self->priv->got_collection_info) {
#line 534 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->full_dates = 0;
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp11_ = _data_->self->priv->collection_info;
#line 3426 "DuplicityJob.c"
			{
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
				_data_->info_collection = _data_->_tmp11_;
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
				for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->_tmp12_ = *((DuplicityJobDateInfo*) _data_->info_it->data);
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
					memset (&_data_->_tmp13_, 0, sizeof (DuplicityJobDateInfo));
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_date_info_copy (&_data_->_tmp12_, &_data_->_tmp13_);
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
					_data_->info = _data_->_tmp13_;
#line 3440 "DuplicityJob.c"
					{
#line 536 "../libdeja/duplicity/DuplicityJob.vala"
						_data_->_tmp14_ = _data_->info;
#line 536 "../libdeja/duplicity/DuplicityJob.vala"
						if (_data_->_tmp14_.full) {
#line 537 "../libdeja/duplicity/DuplicityJob.vala"
							_data_->full_dates = _data_->full_dates + 1;
#line 537 "../libdeja/duplicity/DuplicityJob.vala"
							_data_->_tmp15_ = _data_->full_dates;
#line 3450 "DuplicityJob.c"
						}
#line 535 "../libdeja/duplicity/DuplicityJob.vala"
						duplicity_job_date_info_destroy (&_data_->info);
#line 3454 "DuplicityJob.c"
					}
				}
			}
#line 540 "../libdeja/duplicity/DuplicityJob.vala"
			if (_data_->full_dates > 1) {
#line 541 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_delete_excess (_data_->self, _data_->full_dates - 1);
#line 543 "../libdeja/duplicity/DuplicityJob.vala"
				_data_->self->priv->checked_backup_space = FALSE;
#line 544 "../libdeja/duplicity/DuplicityJob.vala"
				_data_->self->priv->checked_collection_info = FALSE;
#line 545 "../libdeja/duplicity/DuplicityJob.vala"
				_data_->self->priv->got_collection_info = FALSE;
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (_data_->formatted_progress_total);
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
				g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
				if (_data_->_state_ != 0) {
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
					while (!g_task_get_completed (_data_->_async_result)) {
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
						g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3478 "DuplicityJob.c"
					}
				}
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
				g_object_unref (_data_->_async_result);
#line 546 "../libdeja/duplicity/DuplicityJob.vala"
				return FALSE;
#line 3485 "DuplicityJob.c"
			}
		} else {
#line 550 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp16_ = g_strdup (_ ("Backup location does not have enough free space. Try using one with at" \
" least %s."));
#line 550 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_vala1_msg = _data_->_tmp16_;
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp17_ = _data_->_vala1_msg;
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp18_ = _data_->formatted_progress_total;
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp19_ = g_strdup_printf (_data_->_tmp17_, _data_->_tmp18_);
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			duplicity_job_show_error (_data_->self, _data_->_tmp20_, NULL);
#line 551 "../libdeja/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->_tmp20_);
#line 552 "../libdeja/duplicity/DuplicityJob.vala"
			g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->_vala1_msg);
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			_g_free0 (_data_->formatted_progress_total);
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			if (_data_->_state_ != 0) {
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3518 "DuplicityJob.c"
				}
			}
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			g_object_unref (_data_->_async_result);
#line 553 "../libdeja/duplicity/DuplicityJob.vala"
			return FALSE;
#line 3525 "DuplicityJob.c"
		}
	}
#line 557 "../libdeja/duplicity/DuplicityJob.vala"
	if (!duplicity_job_restart (_data_->self)) {
#line 558 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) _data_->self, "done", FALSE, FALSE);
#line 3532 "DuplicityJob.c"
	}
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_data_->formatted_progress_total);
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	if (_data_->_state_ != 0) {
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3544 "DuplicityJob.c"
		}
	}
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	g_object_unref (_data_->_async_result);
#line 506 "../libdeja/duplicity/DuplicityJob.vala"
	return FALSE;
#line 3551 "DuplicityJob.c"
}

static gboolean
duplicity_job_cleanup (DuplicityJob* self)
{
	DuplicityJobState _tmp0_;
	GList* cleanup_argv = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GList* _tmp4_;
	gboolean result;
#line 561 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 562 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_state;
#line 562 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ == DUPLICITY_JOB_STATE_CLEANUP) {
#line 563 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 563 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 3574 "DuplicityJob.c"
	}
#line 565 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_CLEANUP);
#line 566 "../libdeja/duplicity/DuplicityJob.vala"
	cleanup_argv = NULL;
#line 567 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup ("cleanup");
#line 567 "../libdeja/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp1_);
#line 568 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = g_strdup ("--force");
#line 568 "../libdeja/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp2_);
#line 569 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = duplicity_job_get_remote (self);
#line 569 "../libdeja/duplicity/DuplicityJob.vala"
	cleanup_argv = g_list_append (cleanup_argv, _tmp3_);
#line 571 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
#line 572 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = cleanup_argv;
#line 572 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, NULL, NULL, _tmp4_, NULL);
#line 574 "../libdeja/duplicity/DuplicityJob.vala"
	result = TRUE;
#line 574 "../libdeja/duplicity/DuplicityJob.vala"
	(cleanup_argv == NULL) ? NULL : (cleanup_argv = (_g_list_free__g_free0_ (cleanup_argv), NULL));
#line 574 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 3604 "DuplicityJob.c"
}

static void
duplicity_job_delete_excess (DuplicityJob* self,
                             gint cutoff)
{
	GList* argv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 577 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 578 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_state (self, DUPLICITY_JOB_STATE_DELETE);
#line 579 "../libdeja/duplicity/DuplicityJob.vala"
	argv = NULL;
#line 580 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = g_strdup ("remove-all-but-n-full");
#line 580 "../libdeja/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp0_);
#line 581 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup_printf ("%d", cutoff);
#line 581 "../libdeja/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp1_);
#line 582 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = g_strdup ("--force");
#line 582 "../libdeja/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp2_);
#line 583 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = duplicity_job_get_remote (self);
#line 583 "../libdeja/duplicity/DuplicityJob.vala"
	argv = g_list_append (argv, _tmp3_);
#line 585 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_set_status (self, _ ("Cleaning up…"), TRUE);
#line 586 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_connect_and_start (self, NULL, NULL, argv, NULL);
#line 588 "../libdeja/duplicity/DuplicityJob.vala"
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
#line 588 "../libdeja/duplicity/DuplicityJob.vala"
	return;
#line 3646 "DuplicityJob.c"
}

static gboolean
duplicity_job_can_ignore_error (DuplicityJob* self)
{
	DuplicityJobState _tmp0_;
	gboolean result;
#line 591 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 598 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_state;
#line 598 "../libdeja/duplicity/DuplicityJob.vala"
	result = _tmp0_ == DUPLICITY_JOB_STATE_CLEANUP;
#line 598 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 3662 "DuplicityJob.c"
}

static void
duplicity_job_handle_done (DuplicityJob* self,
                           DuplicityInstance* inst,
                           gboolean success,
                           gboolean cancelled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
#line 601 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 603 "../libdeja/duplicity/DuplicityJob.vala"
	if (duplicity_job_can_ignore_error (self)) {
#line 604 "../libdeja/duplicity/DuplicityJob.vala"
		success = TRUE;
#line 3681 "DuplicityJob.c"
	}
#line 606 "../libdeja/duplicity/DuplicityJob.vala"
	if (!cancelled) {
#line 606 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = success;
#line 3687 "DuplicityJob.c"
	} else {
#line 606 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 3691 "DuplicityJob.c"
	}
#line 606 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 3695 "DuplicityJob.c"
		DuplicityJobState _tmp1_;
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->_state;
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
		switch (_tmp1_) {
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_DRY_RUN:
#line 3703 "DuplicityJob.c"
			{
#line 609 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->has_progress_total = TRUE;
#line 610 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->progress_total = self->priv->progress_count;
#line 611 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 612 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 3713 "DuplicityJob.c"
				}
#line 613 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3717 "DuplicityJob.c"
			}
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_DELETE:
#line 3721 "DuplicityJob.c"
			{
#line 616 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 617 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 3727 "DuplicityJob.c"
				}
#line 618 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3731 "DuplicityJob.c"
			}
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_CLEANUP:
#line 3735 "DuplicityJob.c"
			{
#line 621 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->cleaned_up_once = TRUE;
#line 622 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 623 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 3743 "DuplicityJob.c"
				}
#line 627 "../libdeja/duplicity/DuplicityJob.vala"
				success = FALSE;
#line 628 "../libdeja/duplicity/DuplicityJob.vala"
				cancelled = TRUE;
#line 629 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3751 "DuplicityJob.c"
			}
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_STATUS:
#line 3755 "DuplicityJob.c"
			{
				gboolean should_restart = FALSE;
				DejaDupToolJobMode _tmp2_;
				DejaDupToolJobMode _tmp3_;
				DejaDupToolJobMode _tmp4_;
				DejaDupToolJobMode _tmp5_;
#line 632 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->checked_collection_info = TRUE;
#line 633 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 633 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = _tmp2_;
#line 633 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp4_ = self->priv->_original_mode;
#line 633 "../libdeja/duplicity/DuplicityJob.vala"
				should_restart = _tmp3_ != _tmp4_;
#line 634 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp5_ = self->priv->_original_mode;
#line 634 "../libdeja/duplicity/DuplicityJob.vala"
				deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, _tmp5_);
#line 636 "../libdeja/duplicity/DuplicityJob.vala"
				if (should_restart) {
#line 637 "../libdeja/duplicity/DuplicityJob.vala"
					if (duplicity_job_restart (self)) {
#line 638 "../libdeja/duplicity/DuplicityJob.vala"
						return;
#line 3782 "DuplicityJob.c"
					}
				}
#line 640 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3787 "DuplicityJob.c"
			}
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_NORMAL:
#line 3791 "DuplicityJob.c"
			{
				gboolean _tmp6_ = FALSE;
				DejaDupToolJobMode _tmp7_;
				DejaDupToolJobMode _tmp8_;
				DejaDupToolJobMode _tmp14_;
				DejaDupToolJobMode _tmp15_;
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp7_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp8_ = _tmp7_;
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp8_ == DEJA_DUP_TOOL_JOB_MODE_RESTORE) {
#line 3804 "DuplicityJob.c"
					GList* _tmp9_;
					GList* _tmp10_;
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp9_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp10_ = _tmp9_;
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp6_ = _tmp10_ != NULL;
#line 3813 "DuplicityJob.c"
				} else {
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp6_ = FALSE;
#line 3817 "DuplicityJob.c"
				}
#line 643 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp6_) {
#line 3821 "DuplicityJob.c"
					GList* _tmp11_;
					GList* _tmp12_;
					GList* _tmp13_;
#line 644 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp11_ = ((DejaDupToolJob*) self)->_restore_files;
#line 644 "../libdeja/duplicity/DuplicityJob.vala"
					((DejaDupToolJob*) self)->_restore_files = g_list_delete_link (((DejaDupToolJob*) self)->_restore_files, _tmp11_);
#line 645 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp12_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 645 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp13_ = _tmp12_;
#line 645 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp13_ != NULL) {
#line 646 "../libdeja/duplicity/DuplicityJob.vala"
						if (duplicity_job_restart (self)) {
#line 647 "../libdeja/duplicity/DuplicityJob.vala"
							return;
#line 3839 "DuplicityJob.c"
						}
					}
				}
#line 651 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp14_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 651 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp15_ = _tmp14_;
#line 651 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp15_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 652 "../libdeja/duplicity/DuplicityJob.vala"
					deja_dup_tool_job_set_mode ((DejaDupToolJob*) self, DEJA_DUP_TOOL_JOB_MODE_INVALID);
#line 653 "../libdeja/duplicity/DuplicityJob.vala"
					if (duplicity_job_delete_files_if_needed (self)) {
#line 654 "../libdeja/duplicity/DuplicityJob.vala"
						return;
#line 3855 "DuplicityJob.c"
					}
				}
#line 656 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3860 "DuplicityJob.c"
			}
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_STATE_NOT_STARTED:
#line 3864 "DuplicityJob.c"
			{
#line 659 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 3868 "DuplicityJob.c"
			}
			default:
#line 607 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 3873 "DuplicityJob.c"
		}
	} else {
		gboolean _tmp16_;
#line 662 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp16_ = self->priv->_was_stopped;
#line 662 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp16_) {
#line 663 "../libdeja/duplicity/DuplicityJob.vala"
			success = TRUE;
#line 3883 "DuplicityJob.c"
		}
	}
#line 665 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp17_ = self->priv->_error_issued;
#line 665 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp17_) {
#line 666 "../libdeja/duplicity/DuplicityJob.vala"
		success = FALSE;
#line 3892 "DuplicityJob.c"
	}
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
	if (!success) {
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp19_ = !cancelled;
#line 3898 "DuplicityJob.c"
	} else {
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp19_ = FALSE;
#line 3902 "DuplicityJob.c"
	}
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp19_) {
#line 3906 "DuplicityJob.c"
		gboolean _tmp20_;
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp20_ = self->priv->_error_issued;
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp18_ = !_tmp20_;
#line 3912 "DuplicityJob.c"
	} else {
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp18_ = FALSE;
#line 3916 "DuplicityJob.c"
	}
#line 668 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp18_) {
#line 669 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), NULL);
#line 3922 "DuplicityJob.c"
	}
#line 671 "../libdeja/duplicity/DuplicityJob.vala"
	inst = NULL;
#line 672 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "done", success, cancelled);
#line 3928 "DuplicityJob.c"
}

static void
duplicity_job_set_status (DuplicityJob* self,
                          const gchar* msg,
                          gboolean save)
{
#line 678 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 678 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (msg != NULL);
#line 680 "../libdeja/duplicity/DuplicityJob.vala"
	if (save) {
#line 3942 "DuplicityJob.c"
		gchar* _tmp0_;
#line 681 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = g_strdup (msg);
#line 681 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (self->priv->saved_status);
#line 681 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->saved_status = _tmp0_;
#line 682 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->saved_status_file);
#line 682 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file = NULL;
#line 3954 "DuplicityJob.c"
	}
#line 684 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-desc-changed", msg);
#line 3958 "DuplicityJob.c"
}

static void
duplicity_job_set_status_file (DuplicityJob* self,
                               GFile* file,
                               gboolean action,
                               gboolean save)
{
#line 687 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 687 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 689 "../libdeja/duplicity/DuplicityJob.vala"
	if (save) {
#line 3973 "DuplicityJob.c"
		GFile* _tmp0_;
#line 690 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (self->priv->saved_status);
#line 690 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->saved_status = NULL;
#line 691 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = _g_object_ref0 (file);
#line 691 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->saved_status_file);
#line 691 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file = _tmp0_;
#line 692 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->saved_status_file_action = action;
#line 3987 "DuplicityJob.c"
	}
#line 694 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "action-file-changed", file, action);
#line 3991 "DuplicityJob.c"
}

static void
duplicity_job_set_saved_status (DuplicityJob* self)
{
	const gchar* _tmp0_;
#line 697 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 699 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->saved_status;
#line 699 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 4004 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 700 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->saved_status;
#line 700 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_status (self, _tmp1_, FALSE);
#line 4010 "DuplicityJob.c"
	} else {
		GFile* _tmp2_;
#line 702 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = self->priv->saved_status_file;
#line 702 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp2_, self->priv->saved_status_file_action, FALSE);
#line 4017 "DuplicityJob.c"
	}
}

static gboolean
duplicity_job_delete_files_if_needed (DuplicityJob* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 706 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 708 "../libdeja/duplicity/DuplicityJob.vala"
	if (self->priv->delete_age == 0) {
#line 709 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->deleted_files = TRUE;
#line 710 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 710 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4036 "DuplicityJob.c"
	}
#line 716 "../libdeja/duplicity/DuplicityJob.vala"
	if (self->priv->got_collection_info) {
#line 716 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = !self->priv->deleted_files;
#line 4042 "DuplicityJob.c"
	} else {
#line 716 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 4046 "DuplicityJob.c"
	}
#line 716 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 4050 "DuplicityJob.c"
		gint full_dates = 0;
		gint too_old = 0;
		GDateTime* today = NULL;
		GDateTime* _tmp1_;
		GDateTime* prev_time = NULL;
		GList* _tmp2_;
		gboolean _tmp15_ = FALSE;
		GDateTime* _tmp16_;
		gboolean _tmp21_ = FALSE;
#line 718 "../libdeja/duplicity/DuplicityJob.vala"
		full_dates = 0;
#line 719 "../libdeja/duplicity/DuplicityJob.vala"
		too_old = 0;
#line 720 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 720 "../libdeja/duplicity/DuplicityJob.vala"
		today = _tmp1_;
#line 721 "../libdeja/duplicity/DuplicityJob.vala"
		prev_time = NULL;
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = self->priv->collection_info;
#line 4072 "DuplicityJob.c"
		{
			GList* info_collection = NULL;
			GList* info_it = NULL;
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
			info_collection = _tmp2_;
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
			for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
#line 4080 "DuplicityJob.c"
				DuplicityJobDateInfo _tmp3_;
				DuplicityJobDateInfo _tmp4_ = {0};
				DuplicityJobDateInfo info = {0};
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = *((DuplicityJobDateInfo*) info_it->data);
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_date_info_copy (&_tmp3_, &_tmp4_);
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
				info = _tmp4_;
#line 4090 "DuplicityJob.c"
				{
					DuplicityJobDateInfo _tmp5_;
					DuplicityJobDateInfo _tmp12_;
					GDateTime* _tmp13_;
					GDateTime* _tmp14_;
#line 724 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = info;
#line 724 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp5_.full) {
#line 4100 "DuplicityJob.c"
						gboolean _tmp6_ = FALSE;
						GDateTime* _tmp7_;
						gint _tmp11_;
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp7_ = prev_time;
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp7_ != NULL) {
#line 4108 "DuplicityJob.c"
							GDateTime* _tmp8_;
							GDateTime* _tmp9_;
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp8_ = today;
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp9_ = prev_time;
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp6_ = (g_date_time_difference (_tmp8_, _tmp9_) / G_TIME_SPAN_DAY) > ((GTimeSpan) self->priv->delete_age);
#line 4117 "DuplicityJob.c"
						} else {
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp6_ = FALSE;
#line 4121 "DuplicityJob.c"
						}
#line 725 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp6_) {
#line 4125 "DuplicityJob.c"
							gint _tmp10_;
#line 726 "../libdeja/duplicity/DuplicityJob.vala"
							too_old = too_old + 1;
#line 726 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp10_ = too_old;
#line 4131 "DuplicityJob.c"
						}
#line 727 "../libdeja/duplicity/DuplicityJob.vala"
						full_dates = full_dates + 1;
#line 727 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp11_ = full_dates;
#line 4137 "DuplicityJob.c"
					}
#line 729 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp12_ = info;
#line 729 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp13_ = _tmp12_.time;
#line 729 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp14_ = _g_date_time_ref0 (_tmp13_);
#line 729 "../libdeja/duplicity/DuplicityJob.vala"
					_g_date_time_unref0 (prev_time);
#line 729 "../libdeja/duplicity/DuplicityJob.vala"
					prev_time = _tmp14_;
#line 723 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_date_info_destroy (&info);
#line 4151 "DuplicityJob.c"
				}
			}
		}
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp16_ = prev_time;
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp16_ != NULL) {
#line 4159 "DuplicityJob.c"
			GDateTime* _tmp17_;
			GDateTime* _tmp18_;
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp17_ = today;
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp18_ = prev_time;
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp15_ = (g_date_time_difference (_tmp17_, _tmp18_) / G_TIME_SPAN_DAY) > ((GTimeSpan) self->priv->delete_age);
#line 4168 "DuplicityJob.c"
		} else {
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp15_ = FALSE;
#line 4172 "DuplicityJob.c"
		}
#line 731 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp15_) {
#line 4176 "DuplicityJob.c"
			gint _tmp19_;
#line 732 "../libdeja/duplicity/DuplicityJob.vala"
			too_old = too_old + 1;
#line 732 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp19_ = too_old;
#line 4182 "DuplicityJob.c"
		}
#line 737 "../libdeja/duplicity/DuplicityJob.vala"
		if (self->priv->is_full_backup) {
#line 4186 "DuplicityJob.c"
			gint _tmp20_;
#line 738 "../libdeja/duplicity/DuplicityJob.vala"
			full_dates = full_dates + 1;
#line 738 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp20_ = full_dates;
#line 4192 "DuplicityJob.c"
		}
#line 740 "../libdeja/duplicity/DuplicityJob.vala"
		if (too_old > 0) {
#line 740 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp21_ = full_dates > DUPLICITY_JOB_MINIMUM_FULL;
#line 4198 "DuplicityJob.c"
		} else {
#line 740 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp21_ = FALSE;
#line 4202 "DuplicityJob.c"
		}
#line 740 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp21_) {
#line 4206 "DuplicityJob.c"
			gint cutoff = 0;
#line 742 "../libdeja/duplicity/DuplicityJob.vala"
			cutoff = MAX (DUPLICITY_JOB_MINIMUM_FULL, full_dates - too_old);
#line 743 "../libdeja/duplicity/DuplicityJob.vala"
			duplicity_job_delete_excess (self, cutoff);
#line 744 "../libdeja/duplicity/DuplicityJob.vala"
			result = TRUE;
#line 744 "../libdeja/duplicity/DuplicityJob.vala"
			_g_date_time_unref0 (prev_time);
#line 744 "../libdeja/duplicity/DuplicityJob.vala"
			_g_date_time_unref0 (today);
#line 744 "../libdeja/duplicity/DuplicityJob.vala"
			return result;
#line 4220 "DuplicityJob.c"
		}
#line 748 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->deleted_files = TRUE;
#line 749 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 749 "../libdeja/duplicity/DuplicityJob.vala"
		_g_date_time_unref0 (prev_time);
#line 749 "../libdeja/duplicity/DuplicityJob.vala"
		_g_date_time_unref0 (today);
#line 749 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4232 "DuplicityJob.c"
	} else {
#line 752 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 752 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4238 "DuplicityJob.c"
	}
}

static void
duplicity_job_delete_cache (DuplicityJob* self,
                            GRegex* only)
{
	gchar* dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* cachedir = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	DejaDupRecursiveDelete* del = NULL;
	const gchar* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	DejaDupRecursiveDelete* _tmp8_;
	DejaDupRecursiveDelete* _tmp9_;
	DejaDupRecursiveDelete* _tmp10_;
#line 787 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 789 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = g_get_user_cache_dir ();
#line 789 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 789 "../libdeja/duplicity/DuplicityJob.vala"
	dir = _tmp1_;
#line 790 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = dir;
#line 790 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp2_ == NULL) {
#line 791 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (dir);
#line 791 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 4276 "DuplicityJob.c"
	}
#line 793 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = dir;
#line 793 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp4_ = g_build_filename (_tmp3_, PACKAGE, NULL);
#line 793 "../libdeja/duplicity/DuplicityJob.vala"
	cachedir = _tmp4_;
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = cachedir;
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp7_ = _tmp6_;
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp8_ = deja_dup_recursive_delete_new (_tmp7_, "metadata", only);
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp9_ = _tmp8_;
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp7_);
#line 794 "../libdeja/duplicity/DuplicityJob.vala"
	del = _tmp9_;
#line 795 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp10_ = del;
#line 795 "../libdeja/duplicity/DuplicityJob.vala"
	deja_dup_recursive_op_start ((DejaDupRecursiveOp*) _tmp10_);
#line 787 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (del);
#line 787 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (cachedir);
#line 787 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (dir);
#line 4308 "DuplicityJob.c"
}

static gboolean
duplicity_job_restart_without_cache (DuplicityJob* self)
{
	gboolean result;
#line 799 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 801 "../libdeja/duplicity/DuplicityJob.vala"
	if (self->priv->restarted_without_cache) {
#line 802 "../libdeja/duplicity/DuplicityJob.vala"
		result = FALSE;
#line 802 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4323 "DuplicityJob.c"
	}
#line 804 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->restarted_without_cache = TRUE;
#line 806 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_delete_cache (self, NULL);
#line 807 "../libdeja/duplicity/DuplicityJob.vala"
	result = duplicity_job_restart (self);
#line 807 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 4333 "DuplicityJob.c"
}

static void
duplicity_job_handle_exit (DuplicityJob* self,
                           gint code)
{
	gboolean _tmp0_ = FALSE;
#line 810 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 818 "../libdeja/duplicity/DuplicityJob.vala"
	if (code == DUPLICITY_JOB_ERROR_GENERIC) {
#line 4345 "DuplicityJob.c"
		gboolean _tmp1_;
#line 818 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->_error_issued;
#line 818 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = !_tmp1_;
#line 4351 "DuplicityJob.c"
	} else {
#line 818 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = FALSE;
#line 4355 "DuplicityJob.c"
	}
#line 818 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 819 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_restart_without_cache (self);
#line 4361 "DuplicityJob.c"
	}
}

static void
duplicity_job_handle_message (DuplicityJob* self,
                              DuplicityInstance* inst,
                              gchar** control_line,
                              gint control_line_length1,
                              GList* data_lines,
                              const gchar* user_text)
{
	gchar* keyword = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GQuark _tmp5_ = 0U;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label0 = 0;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label1 = 0;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp4_label2 = 0;
#line 823 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 823 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (inst != NULL);
#line 823 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (user_text != NULL);
#line 829 "../libdeja/duplicity/DuplicityJob.vala"
	if (control_line_length1 == 0) {
#line 830 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 4395 "DuplicityJob.c"
	}
#line 832 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = control_line[0];
#line 832 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 832 "../libdeja/duplicity/DuplicityJob.vala"
	keyword = _tmp1_;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = keyword;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = (NULL == _tmp3_) ? 0 : g_quark_from_string (_tmp3_);
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp5_ == ((0 != _tmp4_label0) ? _tmp4_label0 : (_tmp4_label0 = g_quark_from_static_string ("ERROR")))) {
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4413 "DuplicityJob.c"
			default:
			{
#line 835 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_error (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 836 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4420 "DuplicityJob.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label1) ? _tmp4_label1 : (_tmp4_label1 = g_quark_from_static_string ("INFO")))) {
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4426 "DuplicityJob.c"
			default:
			{
#line 838 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_info (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 839 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4433 "DuplicityJob.c"
			}
		}
	} else if (_tmp5_ == ((0 != _tmp4_label2) ? _tmp4_label2 : (_tmp4_label2 = g_quark_from_static_string ("WARNING")))) {
#line 833 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 4439 "DuplicityJob.c"
			default:
			{
#line 841 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_warning (self, control_line, (gint) control_line_length1, data_lines, user_text);
#line 842 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4446 "DuplicityJob.c"
			}
		}
	}
#line 823 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (keyword);
#line 4452 "DuplicityJob.c"
}

static gboolean
duplicity_job_ask_question (DuplicityJob* self,
                            const gchar* t,
                            const gchar* m)
{
	gboolean rv = FALSE;
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	gboolean result;
#line 846 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 846 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (t != NULL, FALSE);
#line 846 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 848 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 849 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "question", t, m);
#line 850 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 850 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 850 "../libdeja/duplicity/DuplicityJob.vala"
	rv = _tmp1_ != DEJA_DUP_TOOL_JOB_MODE_INVALID;
#line 851 "../libdeja/duplicity/DuplicityJob.vala"
	if (!rv) {
#line 852 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_handle_done (self, NULL, FALSE, TRUE);
#line 4484 "DuplicityJob.c"
	}
#line 853 "../libdeja/duplicity/DuplicityJob.vala"
	result = rv;
#line 853 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 4490 "DuplicityJob.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 4512 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 4520 "DuplicityJob.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 4526 "DuplicityJob.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1455 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1455 "glib-2.0.vapi"
	end = _tmp0_;
#line 1456 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1456 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1457 "glib-2.0.vapi"
		result = maxlen;
#line 1457 "glib-2.0.vapi"
		return result;
#line 4550 "DuplicityJob.c"
	} else {
		gchar* _tmp2_;
#line 1459 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1459 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1459 "glib-2.0.vapi"
		return result;
#line 4559 "DuplicityJob.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1466 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1468 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4578 "DuplicityJob.c"
	} else {
#line 1468 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4582 "DuplicityJob.c"
	}
#line 1468 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1470 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4588 "DuplicityJob.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1472 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1472 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1472 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4598 "DuplicityJob.c"
	}
#line 1475 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1476 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1477 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4606 "DuplicityJob.c"
	} else {
#line 1479 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 4610 "DuplicityJob.c"
	}
#line 1481 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1482 "glib-2.0.vapi"
		len = string_length - offset;
#line 4616 "DuplicityJob.c"
	}
#line 1484 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1485 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1485 "glib-2.0.vapi"
	result = _tmp3_;
#line 1485 "glib-2.0.vapi"
	return result;
#line 4626 "DuplicityJob.c"
}

static gchar*
duplicity_job_parse_duplicity_file (DuplicityJob* self,
                                    const gchar* file,
                                    gint skip_bits)
{
	gint next = 0;
	gchar* result;
#line 858 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 858 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 860 "../libdeja/duplicity/DuplicityJob.vala"
	next = 0;
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
	while (TRUE) {
#line 4644 "DuplicityJob.c"
		gboolean _tmp0_ = FALSE;
		gint _tmp1_;
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = skip_bits;
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
		skip_bits = _tmp1_ - 1;
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp1_ > 0) {
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp0_ = next >= 0;
#line 4655 "DuplicityJob.c"
		} else {
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp0_ = FALSE;
#line 4659 "DuplicityJob.c"
		}
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
		if (!_tmp0_) {
#line 861 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 4665 "DuplicityJob.c"
		}
#line 862 "../libdeja/duplicity/DuplicityJob.vala"
		next = string_index_of_char (file, (gunichar) '.', next) + 1;
#line 4669 "DuplicityJob.c"
	}
#line 863 "../libdeja/duplicity/DuplicityJob.vala"
	if (next < 0) {
#line 4673 "DuplicityJob.c"
		gchar* _tmp2_;
#line 864 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = g_strdup ("");
#line 864 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp2_;
#line 864 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4681 "DuplicityJob.c"
	} else {
		gchar* _tmp3_;
#line 866 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = string_substring (file, (glong) next, (glong) -1);
#line 866 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp3_;
#line 866 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4690 "DuplicityJob.c"
	}
}

static void
duplicity_job_report_encryption_error (DuplicityJob* self)
{
#line 869 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 871 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "bad-encryption-password");
#line 872 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_show_error (self, _ ("Bad encryption password."), NULL);
#line 4703 "DuplicityJob.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1538 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1539 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1539 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1539 "glib-2.0.vapi"
	return result;
#line 4722 "DuplicityJob.c"
}

static gboolean
duplicity_job_check_encryption_error (DuplicityJob* self,
                                      const gchar* text)
{
	gchar* no_seckey_msg = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* bad_key_msg = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gboolean result;
#line 875 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 875 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 884 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = gpg_strerror (GPG_ERR_NO_SECKEY);
#line 884 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 884 "../libdeja/duplicity/DuplicityJob.vala"
	no_seckey_msg = _tmp1_;
#line 885 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = gpg_strerror (GPG_ERR_BAD_KEY);
#line 885 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 885 "../libdeja/duplicity/DuplicityJob.vala"
	bad_key_msg = _tmp3_;
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp7_ = no_seckey_msg;
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
	if (string_contains (text, _tmp7_)) {
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = TRUE;
#line 4762 "DuplicityJob.c"
	} else {
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = string_contains (text, "No secret key");
#line 4766 "DuplicityJob.c"
	}
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp6_) {
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = TRUE;
#line 4772 "DuplicityJob.c"
	} else {
		const gchar* _tmp8_;
#line 887 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp8_ = bad_key_msg;
#line 887 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = string_contains (text, _tmp8_);
#line 4779 "DuplicityJob.c"
	}
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp5_) {
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = TRUE;
#line 4785 "DuplicityJob.c"
	} else {
#line 887 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = string_contains (text, "Bad session key");
#line 4789 "DuplicityJob.c"
	}
#line 886 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp4_) {
#line 889 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_report_encryption_error (self);
#line 890 "../libdeja/duplicity/DuplicityJob.vala"
		result = TRUE;
#line 890 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (bad_key_msg);
#line 890 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (no_seckey_msg);
#line 890 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 4803 "DuplicityJob.c"
	}
#line 893 "../libdeja/duplicity/DuplicityJob.vala"
	result = FALSE;
#line 893 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (bad_key_msg);
#line 893 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (no_seckey_msg);
#line 893 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 4813 "DuplicityJob.c"
}

static void
duplicity_job_real_process_error (DuplicityJob* self,
                                  gchar** firstline,
                                  gint firstline_length1,
                                  GList* data,
                                  const gchar* text_in)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	const gchar* _tmp74_;
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (text_in != NULL);
#line 899 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = g_strdup (text_in);
#line 899 "../libdeja/duplicity/DuplicityJob.vala"
	text = _tmp0_;
#line 901 "../libdeja/duplicity/DuplicityJob.vala"
	if (duplicity_job_can_ignore_error (self)) {
#line 902 "../libdeja/duplicity/DuplicityJob.vala"
		_g_free0 (text);
#line 902 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 4838 "DuplicityJob.c"
	}
#line 904 "../libdeja/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 4842 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = firstline[1];
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp1_)) {
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_GENERIC:
#line 4850 "DuplicityJob.c"
			{
				gboolean _tmp2_ = FALSE;
				const gchar* _tmp3_;
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = text;
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
				if (string_contains (_tmp3_, "GnuPG")) {
#line 4858 "DuplicityJob.c"
					const gchar* _tmp4_;
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp4_ = text;
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp2_ = duplicity_job_check_encryption_error (self, _tmp4_);
#line 4864 "DuplicityJob.c"
				} else {
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp2_ = FALSE;
#line 4868 "DuplicityJob.c"
				}
#line 908 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp2_) {
#line 909 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 909 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 4876 "DuplicityJob.c"
				}
#line 910 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4880 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_EXCEPTION:
#line 4884 "DuplicityJob.c"
			{
				const gchar* _tmp5_ = NULL;
				const gchar* _tmp7_;
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 4890 "DuplicityJob.c"
					const gchar* _tmp6_;
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp6_ = firstline[2];
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = _tmp6_;
#line 4896 "DuplicityJob.c"
				} else {
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = "";
#line 4900 "DuplicityJob.c"
				}
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp7_ = text;
#line 913 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_exception (self, _tmp5_, _tmp7_);
#line 914 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (text);
#line 914 "../libdeja/duplicity/DuplicityJob.vala"
				return;
#line 4910 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_RESTORE_DIR_NOT_FOUND:
#line 4914 "DuplicityJob.c"
			{
				GList* _tmp8_;
				GList* _tmp9_;
#line 920 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp8_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 920 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp9_ = _tmp8_;
#line 920 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp9_ != NULL) {
#line 4924 "DuplicityJob.c"
					GList* _tmp10_;
					GList* _tmp11_;
					gconstpointer _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp10_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp11_ = _tmp10_;
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp12_ = _tmp11_->data;
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp13_ = g_file_get_parse_name ((GFile*) _tmp12_);
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp14_ = _tmp13_;
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp15_ = g_strdup_printf (_ ("Could not restore ‘%s’: File not found in backup"), _tmp14_);
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					text = _tmp15_;
#line 921 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp14_);
#line 4949 "DuplicityJob.c"
				}
#line 923 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4953 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_GPG:
#line 4957 "DuplicityJob.c"
			{
#line 926 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_check_encryption_error (self, text_in)) {
#line 927 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 927 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 4965 "DuplicityJob.c"
				}
#line 928 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 4969 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_HOSTNAME_CHANGED:
#line 4973 "DuplicityJob.c"
			{
				gchar* _tmp23_;
#line 931 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 4) {
#line 4978 "DuplicityJob.c"
					gchar* msg = NULL;
					gchar* _tmp16_;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gboolean _tmp22_;
#line 932 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp16_ = g_strdup (_ ("The existing backup is of a computer named %s, but the " "current computer’s name is %s.  If this is unexpected, " "you should back up to a different location."));
#line 932 "../libdeja/duplicity/DuplicityJob.vala"
					msg = _tmp16_;
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp17_ = msg;
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp18_ = firstline[3];
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp19_ = firstline[2];
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp20_ = g_strdup_printf (_tmp17_, _tmp18_, _tmp19_);
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp21_ = _tmp20_;
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp22_ = !duplicity_job_ask_question (self, _ ("Computer name changed"), _tmp21_);
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp21_);
#line 935 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp22_) {
#line 936 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (msg);
#line 936 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 936 "../libdeja/duplicity/DuplicityJob.vala"
						return;
#line 5013 "DuplicityJob.c"
					}
#line 931 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (msg);
#line 5017 "DuplicityJob.c"
				}
#line 940 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp23_ = g_strdup ("--allow-source-mismatch");
#line 940 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->saved_argv = g_list_append (self->priv->saved_argv, _tmp23_);
#line 941 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart (self)) {
#line 942 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 942 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 5029 "DuplicityJob.c"
				}
#line 943 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5033 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BAD_VOLUME:
#line 5037 "DuplicityJob.c"
			{
				DejaDupToolJobMode _tmp24_;
				DejaDupToolJobMode _tmp25_;
#line 951 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp24_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 951 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp25_ = _tmp24_;
#line 951 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp25_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5047 "DuplicityJob.c"
					gchar* this_volume = NULL;
					const gchar* _tmp26_;
					gchar* _tmp27_;
					const gchar* _tmp28_;
					const gchar* _tmp29_;
					gboolean _tmp32_ = FALSE;
					gboolean _tmp33_ = FALSE;
#line 953 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp26_ = firstline[2];
#line 953 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp27_ = duplicity_job_parse_duplicity_file (self, _tmp26_, 2);
#line 953 "../libdeja/duplicity/DuplicityJob.vala"
					this_volume = _tmp27_;
#line 954 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp28_ = self->priv->last_bad_volume;
#line 954 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp29_ = this_volume;
#line 954 "../libdeja/duplicity/DuplicityJob.vala"
					if (g_strcmp0 (_tmp28_, _tmp29_) != 0) {
#line 5067 "DuplicityJob.c"
						const gchar* _tmp30_;
						gchar* _tmp31_;
#line 955 "../libdeja/duplicity/DuplicityJob.vala"
						self->priv->bad_volume_count = (guint) 0;
#line 956 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp30_ = this_volume;
#line 956 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp31_ = g_strdup (_tmp30_);
#line 956 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (self->priv->last_bad_volume);
#line 956 "../libdeja/duplicity/DuplicityJob.vala"
						self->priv->last_bad_volume = _tmp31_;
#line 5080 "DuplicityJob.c"
					}
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
					if (self->priv->bad_volume_count == ((guint) 0)) {
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp33_ = duplicity_job_restart (self);
#line 5086 "DuplicityJob.c"
					} else {
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp33_ = FALSE;
#line 5090 "DuplicityJob.c"
					}
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp33_) {
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp32_ = TRUE;
#line 5096 "DuplicityJob.c"
					} else {
						gboolean _tmp34_ = FALSE;
#line 960 "../libdeja/duplicity/DuplicityJob.vala"
						if (self->priv->bad_volume_count == ((guint) 1)) {
#line 960 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp34_ = duplicity_job_cleanup (self);
#line 5103 "DuplicityJob.c"
						} else {
#line 960 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp34_ = FALSE;
#line 5107 "DuplicityJob.c"
						}
#line 960 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp32_ = _tmp34_;
#line 5111 "DuplicityJob.c"
					}
#line 959 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp32_) {
#line 961 "../libdeja/duplicity/DuplicityJob.vala"
						self->priv->bad_volume_count = self->priv->bad_volume_count + 1;
#line 962 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (this_volume);
#line 962 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 962 "../libdeja/duplicity/DuplicityJob.vala"
						return;
#line 5123 "DuplicityJob.c"
					}
#line 951 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (this_volume);
#line 5127 "DuplicityJob.c"
				}
#line 965 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5131 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_PERMISSION_DENIED:
#line 5135 "DuplicityJob.c"
			{
				gboolean _tmp35_ = FALSE;
				gboolean _tmp43_ = FALSE;
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5141 "DuplicityJob.c"
					const gchar* _tmp36_;
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp36_ = firstline[2];
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp35_ = g_strcmp0 (_tmp36_, "put") == 0;
#line 5147 "DuplicityJob.c"
				} else {
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp35_ = FALSE;
#line 5151 "DuplicityJob.c"
				}
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp35_) {
#line 5155 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp37_;
					GFile* _tmp38_;
					GFile* _tmp39_;
					gchar* _tmp40_;
					gchar* _tmp41_;
					gchar* _tmp42_;
#line 969 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp37_ = firstline[4];
#line 969 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp38_ = duplicity_job_make_file_obj (self, _tmp37_);
#line 969 "../libdeja/duplicity/DuplicityJob.vala"
					file = _tmp38_;
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp39_ = file;
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp40_ = g_file_get_parse_name (_tmp39_);
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp41_ = _tmp40_;
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp42_ = g_strdup_printf (_ ("Permission denied when trying to create ‘%s’."), _tmp41_);
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					text = _tmp42_;
#line 970 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp41_);
#line 968 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5185 "DuplicityJob.c"
				}
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5189 "DuplicityJob.c"
					const gchar* _tmp44_;
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp44_ = firstline[2];
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp43_ = g_strcmp0 (_tmp44_, "get") == 0;
#line 5195 "DuplicityJob.c"
				} else {
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp43_ = FALSE;
#line 5199 "DuplicityJob.c"
				}
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp43_) {
#line 5203 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp45_;
					GFile* _tmp46_;
					GFile* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
					gchar* _tmp50_;
#line 973 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp45_ = firstline[3];
#line 973 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp46_ = duplicity_job_make_file_obj (self, _tmp45_);
#line 973 "../libdeja/duplicity/DuplicityJob.vala"
					file = _tmp46_;
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp47_ = file;
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp48_ = g_file_get_parse_name (_tmp47_);
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp49_ = _tmp48_;
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp50_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp49_);
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					text = _tmp50_;
#line 974 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp49_);
#line 972 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5233 "DuplicityJob.c"
				} else {
					gboolean _tmp51_ = FALSE;
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
					if (firstline_length1 >= 4) {
#line 5238 "DuplicityJob.c"
						const gchar* _tmp52_;
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp52_ = firstline[2];
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp51_ = g_strcmp0 (_tmp52_, "list") == 0;
#line 5244 "DuplicityJob.c"
					} else {
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp51_ = FALSE;
#line 5248 "DuplicityJob.c"
					}
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp51_) {
#line 5252 "DuplicityJob.c"
						GFile* file = NULL;
						const gchar* _tmp53_;
						GFile* _tmp54_;
						GFile* _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
						gchar* _tmp58_;
#line 977 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp53_ = firstline[3];
#line 977 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp54_ = duplicity_job_make_file_obj (self, _tmp53_);
#line 977 "../libdeja/duplicity/DuplicityJob.vala"
						file = _tmp54_;
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp55_ = file;
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp56_ = g_file_get_parse_name (_tmp55_);
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp57_ = _tmp56_;
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp58_ = g_strdup_printf (_ ("Permission denied when trying to read ‘%s’."), _tmp57_);
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (text);
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						text = _tmp58_;
#line 978 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (_tmp57_);
#line 976 "../libdeja/duplicity/DuplicityJob.vala"
						_g_object_unref0 (file);
#line 5282 "DuplicityJob.c"
					} else {
						gboolean _tmp59_ = FALSE;
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
						if (firstline_length1 >= 4) {
#line 5287 "DuplicityJob.c"
							const gchar* _tmp60_;
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp60_ = firstline[2];
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp59_ = g_strcmp0 (_tmp60_, "delete") == 0;
#line 5293 "DuplicityJob.c"
						} else {
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp59_ = FALSE;
#line 5297 "DuplicityJob.c"
						}
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp59_) {
#line 5301 "DuplicityJob.c"
							GFile* file = NULL;
							const gchar* _tmp61_;
							GFile* _tmp62_;
							GFile* _tmp63_;
							gchar* _tmp64_;
							gchar* _tmp65_;
							gchar* _tmp66_;
#line 981 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp61_ = firstline[3];
#line 981 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp62_ = duplicity_job_make_file_obj (self, _tmp61_);
#line 981 "../libdeja/duplicity/DuplicityJob.vala"
							file = _tmp62_;
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp63_ = file;
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp64_ = g_file_get_parse_name (_tmp63_);
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp65_ = _tmp64_;
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp66_ = g_strdup_printf (_ ("Permission denied when trying to delete ‘%s’."), _tmp65_);
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (text);
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							text = _tmp66_;
#line 982 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp65_);
#line 980 "../libdeja/duplicity/DuplicityJob.vala"
							_g_object_unref0 (file);
#line 5331 "DuplicityJob.c"
						}
					}
				}
#line 984 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5337 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_NOT_FOUND:
#line 5341 "DuplicityJob.c"
			{
#line 987 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 4) {
#line 5345 "DuplicityJob.c"
					GFile* file = NULL;
					const gchar* _tmp67_;
					GFile* _tmp68_;
					GFile* _tmp69_;
					gchar* _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
#line 988 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp67_ = firstline[3];
#line 988 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp68_ = duplicity_job_make_file_obj (self, _tmp67_);
#line 988 "../libdeja/duplicity/DuplicityJob.vala"
					file = _tmp68_;
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp69_ = file;
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp70_ = g_file_get_parse_name (_tmp69_);
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp71_ = _tmp70_;
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp72_ = g_strdup_printf (_ ("Backup location ‘%s’ does not exist."), _tmp71_);
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					text = _tmp72_;
#line 989 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (_tmp71_);
#line 987 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (file);
#line 5375 "DuplicityJob.c"
				}
#line 991 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5379 "DuplicityJob.c"
			}
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_ERROR_BACKEND_NO_SPACE:
#line 5383 "DuplicityJob.c"
			{
#line 994 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 >= 5) {
#line 5387 "DuplicityJob.c"
					gchar* _tmp73_;
#line 995 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp73_ = g_strdup (_ ("No space left."));
#line 995 "../libdeja/duplicity/DuplicityJob.vala"
					_g_free0 (text);
#line 995 "../libdeja/duplicity/DuplicityJob.vala"
					text = _tmp73_;
#line 5395 "DuplicityJob.c"
				}
#line 997 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5399 "DuplicityJob.c"
			}
			default:
#line 905 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 5404 "DuplicityJob.c"
		}
	}
#line 1001 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp74_ = text;
#line 1001 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_show_error (self, _tmp74_, NULL);
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (text);
#line 5413 "DuplicityJob.c"
}

void
duplicity_job_process_error (DuplicityJob* self,
                             gchar** firstline,
                             gint firstline_length1,
                             GList* data,
                             const gchar* text_in)
{
	DuplicityJobClass* _klass_;
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
	_klass_ = DUPLICITY_JOB_GET_CLASS (self);
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
	if (_klass_->process_error) {
#line 896 "../libdeja/duplicity/DuplicityJob.vala"
		_klass_->process_error (self, firstline, firstline_length1, data, text_in);
#line 5432 "DuplicityJob.c"
	}
}

static void
duplicity_job_process_exception (DuplicityJob* self,
                                 const gchar* exception,
                                 const gchar* text)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label0 = 0;
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label1 = 0;
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label2 = 0;
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	static GQuark _tmp1_label3 = 0;
#line 5451 "DuplicityJob.c"
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_;
#line 1004 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1004 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (exception != NULL);
#line 1004 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = exception;
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("EOFError")))) {
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5468 "DuplicityJob.c"
			default:
			{
#line 1009 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_report_encryption_error (self);
#line 1010 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5475 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("IOError")))) {
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5481 "DuplicityJob.c"
			default:
			{
#line 1012 "../libdeja/duplicity/DuplicityJob.vala"
				if (string_contains (text, "GnuPG")) {
#line 1013 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_report_encryption_error (self);
#line 5488 "DuplicityJob.c"
				} else {
					gboolean _tmp3_ = FALSE;
#line 1014 "../libdeja/duplicity/DuplicityJob.vala"
					if (string_contains (text, "[Errno 5]")) {
#line 5493 "DuplicityJob.c"
						GFile* _tmp4_;
#line 1015 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp4_ = self->priv->last_touched_file;
#line 1015 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp3_ = _tmp4_ != NULL;
#line 5499 "DuplicityJob.c"
					} else {
#line 1014 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp3_ = FALSE;
#line 5503 "DuplicityJob.c"
					}
#line 1014 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp3_) {
#line 5507 "DuplicityJob.c"
						DejaDupToolJobMode _tmp5_;
						DejaDupToolJobMode _tmp6_;
#line 1016 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp5_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1016 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp6_ = _tmp5_;
#line 1016 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp6_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5516 "DuplicityJob.c"
							GFile* _tmp7_;
							gchar* _tmp8_;
							gchar* _tmp9_;
							gchar* _tmp10_;
							gchar* _tmp11_;
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp7_ = self->priv->last_touched_file;
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp8_ = g_file_get_parse_name (_tmp7_);
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp9_ = _tmp8_;
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp10_ = g_strdup_printf (_ ("Error reading file ‘%s’."), _tmp9_);
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp11_ = _tmp10_;
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp11_, NULL);
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp11_);
#line 1017 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp9_);
#line 5538 "DuplicityJob.c"
						} else {
							GFile* _tmp12_;
							gchar* _tmp13_;
							gchar* _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp12_ = self->priv->last_touched_file;
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp13_ = g_file_get_parse_name (_tmp12_);
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp14_ = _tmp13_;
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp15_ = g_strdup_printf (_ ("Error writing file ‘%s’."), _tmp14_);
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp16_ = _tmp15_;
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							duplicity_job_show_error (self, _tmp16_, NULL);
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp16_);
#line 1019 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (_tmp14_);
#line 5561 "DuplicityJob.c"
						}
					} else {
#line 1021 "../libdeja/duplicity/DuplicityJob.vala"
						if (string_contains (text, "[Errno 28]")) {
#line 5566 "DuplicityJob.c"
							gchar* where = NULL;
							DejaDupToolJobMode _tmp17_;
							DejaDupToolJobMode _tmp18_;
							const gchar* _tmp25_;
#line 1022 "../libdeja/duplicity/DuplicityJob.vala"
							where = NULL;
#line 1023 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp17_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1023 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp18_ = _tmp17_;
#line 1023 "../libdeja/duplicity/DuplicityJob.vala"
							if (_tmp18_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 5579 "DuplicityJob.c"
								DejaDupBackend* _tmp19_;
								DejaDupBackend* _tmp20_;
								gchar* _tmp21_;
#line 1024 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp19_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1024 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp20_ = _tmp19_;
#line 1024 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp21_ = deja_dup_backend_get_location_pretty (_tmp20_);
#line 1024 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (where);
#line 1024 "../libdeja/duplicity/DuplicityJob.vala"
								where = _tmp21_;
#line 5593 "DuplicityJob.c"
							} else {
								GFile* _tmp22_;
								GFile* _tmp23_;
								gchar* _tmp24_;
#line 1026 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp22_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 1026 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp23_ = _tmp22_;
#line 1026 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp24_ = g_file_get_path (_tmp23_);
#line 1026 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (where);
#line 1026 "../libdeja/duplicity/DuplicityJob.vala"
								where = _tmp24_;
#line 5608 "DuplicityJob.c"
							}
#line 1027 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp25_ = where;
#line 1027 "../libdeja/duplicity/DuplicityJob.vala"
							if (_tmp25_ == NULL) {
#line 1028 "../libdeja/duplicity/DuplicityJob.vala"
								duplicity_job_show_error (self, _ ("No space left."), NULL);
#line 5616 "DuplicityJob.c"
							} else {
								const gchar* _tmp26_;
								gchar* _tmp27_;
								gchar* _tmp28_;
#line 1030 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp26_ = where;
#line 1030 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp27_ = g_strdup_printf (_ ("No space left in ‘%s’."), _tmp26_);
#line 1030 "../libdeja/duplicity/DuplicityJob.vala"
								_tmp28_ = _tmp27_;
#line 1030 "../libdeja/duplicity/DuplicityJob.vala"
								duplicity_job_show_error (self, _tmp28_, NULL);
#line 1030 "../libdeja/duplicity/DuplicityJob.vala"
								_g_free0 (_tmp28_);
#line 5631 "DuplicityJob.c"
							}
#line 1021 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (where);
#line 5635 "DuplicityJob.c"
						} else {
#line 1032 "../libdeja/duplicity/DuplicityJob.vala"
							if (string_contains (text, "CRC check failed")) {
#line 1033 "../libdeja/duplicity/DuplicityJob.vala"
								if (duplicity_job_restart_without_cache (self)) {
#line 1034 "../libdeja/duplicity/DuplicityJob.vala"
									return;
#line 5643 "DuplicityJob.c"
								}
							}
						}
					}
				}
#line 1036 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5651 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("CollectionsError")))) {
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5657 "DuplicityJob.c"
			default:
			{
#line 1038 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_show_error (self, _ ("No backup files found"), NULL);
#line 1039 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5664 "DuplicityJob.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("AssertionError")))) {
#line 1006 "../libdeja/duplicity/DuplicityJob.vala"
		switch (0) {
#line 5670 "DuplicityJob.c"
			default:
			{
#line 1045 "../libdeja/duplicity/DuplicityJob.vala"
				if (duplicity_job_restart_without_cache (self)) {
#line 1046 "../libdeja/duplicity/DuplicityJob.vala"
					return;
#line 5677 "DuplicityJob.c"
				}
#line 1047 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5681 "DuplicityJob.c"
			}
		}
	}
#line 1056 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp30_ = self->priv->_error_issued;
#line 1056 "../libdeja/duplicity/DuplicityJob.vala"
	if (!_tmp30_) {
#line 1056 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp29_ = !duplicity_job_restart_without_cache (self);
#line 5691 "DuplicityJob.c"
	} else {
#line 1056 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp29_ = FALSE;
#line 5695 "DuplicityJob.c"
	}
#line 1056 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp29_) {
#line 1057 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_show_error (self, _ ("Failed with an unknown error."), text);
#line 5701 "DuplicityJob.c"
	}
}

static void
duplicity_job_real_process_info (DuplicityJob* self,
                                 gchar** firstline,
                                 gint firstline_length1,
                                 GList* data,
                                 const gchar* text)
{
#line 1060 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1066 "../libdeja/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 5716 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[1];
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp0_)) {
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_NEW:
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_CHANGED:
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_DIFF_FILE_DELETED:
#line 5728 "DuplicityJob.c"
			{
#line 1071 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 5732 "DuplicityJob.c"
					const gchar* _tmp1_;
#line 1072 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp1_ = firstline[2];
#line 1072 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_process_diff_file (self, _tmp1_);
#line 5738 "DuplicityJob.c"
				}
#line 1073 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5742 "DuplicityJob.c"
			}
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PATCH_FILE_WRITING:
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PATCH_FILE_PATCHING:
#line 5748 "DuplicityJob.c"
			{
#line 1076 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 5752 "DuplicityJob.c"
					const gchar* _tmp2_;
#line 1077 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp2_ = firstline[2];
#line 1077 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_process_patch_file (self, _tmp2_);
#line 5758 "DuplicityJob.c"
				}
#line 1078 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5762 "DuplicityJob.c"
			}
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_PROGRESS:
#line 5766 "DuplicityJob.c"
			{
#line 1080 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_progress (self, firstline, (gint) firstline_length1);
#line 1081 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5772 "DuplicityJob.c"
			}
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_COLLECTION_STATUS:
#line 5776 "DuplicityJob.c"
			{
#line 1083 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_collection_status (self, data);
#line 1084 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5782 "DuplicityJob.c"
			}
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_SYNCHRONOUS_UPLOAD_BEGIN:
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_ASYNCHRONOUS_UPLOAD_BEGIN:
#line 5788 "DuplicityJob.c"
			{
				DejaDupBackend* _tmp3_;
				DejaDupBackend* _tmp4_;
#line 1087 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = deja_dup_tool_job_get_backend ((DejaDupToolJob*) self);
#line 1087 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp4_ = _tmp3_;
#line 1087 "../libdeja/duplicity/DuplicityJob.vala"
				if (!deja_dup_backend_is_native (_tmp4_)) {
#line 1088 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_set_status (self, _ ("Uploading…"), TRUE);
#line 5800 "DuplicityJob.c"
				}
#line 1089 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5804 "DuplicityJob.c"
			}
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_INFO_FILE_STAT:
#line 5808 "DuplicityJob.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
#line 1091 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp5_ = firstline[2];
#line 1091 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp6_ = firstline[3];
#line 1091 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp7_ = firstline[4];
#line 1091 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_process_file_stat (self, _tmp5_, _tmp6_, _tmp7_, data, text);
#line 1092 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 5823 "DuplicityJob.c"
			}
			default:
#line 1067 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 5828 "DuplicityJob.c"
		}
	}
}

void
duplicity_job_process_info (DuplicityJob* self,
                            gchar** firstline,
                            gint firstline_length1,
                            GList* data,
                            const gchar* text)
{
	DuplicityJobClass* _klass_;
#line 1060 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1060 "../libdeja/duplicity/DuplicityJob.vala"
	_klass_ = DUPLICITY_JOB_GET_CLASS (self);
#line 1060 "../libdeja/duplicity/DuplicityJob.vala"
	if (_klass_->process_info) {
#line 1060 "../libdeja/duplicity/DuplicityJob.vala"
		_klass_->process_info (self, firstline, firstline_length1, data, text);
#line 5849 "DuplicityJob.c"
	}
}

static void
duplicity_job_process_file_stat (DuplicityJob* self,
                                 const gchar* date,
                                 const gchar* file,
                                 const gchar* dup_type,
                                 GList* data,
                                 const gchar* text)
{
	DejaDupToolJobMode _tmp0_;
	DejaDupToolJobMode _tmp1_;
	GFileType file_type = 0;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 1097 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1097 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (date != NULL);
#line 1097 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1097 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (dup_type != NULL);
#line 1097 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1099 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1099 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 1099 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp1_ != DEJA_DUP_TOOL_JOB_MODE_LIST) {
#line 1100 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 5884 "DuplicityJob.c"
	}
#line 1101 "../libdeja/duplicity/DuplicityJob.vala"
	if (g_strcmp0 (file, ".") == 0) {
#line 1102 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 5890 "DuplicityJob.c"
	}
#line 1104 "../libdeja/duplicity/DuplicityJob.vala"
	file_type = G_FILE_TYPE_UNKNOWN;
#line 1105 "../libdeja/duplicity/DuplicityJob.vala"
	if (g_strcmp0 (dup_type, "reg") == 0) {
#line 1106 "../libdeja/duplicity/DuplicityJob.vala"
		file_type = G_FILE_TYPE_REGULAR;
#line 5898 "DuplicityJob.c"
	} else {
#line 1107 "../libdeja/duplicity/DuplicityJob.vala"
		if (g_strcmp0 (dup_type, "dir") == 0) {
#line 1108 "../libdeja/duplicity/DuplicityJob.vala"
			file_type = G_FILE_TYPE_DIRECTORY;
#line 5904 "DuplicityJob.c"
		} else {
#line 1109 "../libdeja/duplicity/DuplicityJob.vala"
			if (g_strcmp0 (dup_type, "sym") == 0) {
#line 1110 "../libdeja/duplicity/DuplicityJob.vala"
				file_type = G_FILE_TYPE_SYMBOLIC_LINK;
#line 5910 "DuplicityJob.c"
			}
		}
	}
#line 1112 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = g_strconcat ("/", file, NULL);
#line 1112 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = _tmp2_;
#line 1112 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "listed-current-files", _tmp3_, file_type);
#line 1112 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (_tmp3_);
#line 5922 "DuplicityJob.c"
}

static void
duplicity_job_process_diff_file (DuplicityJob* self,
                                 const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1115 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1115 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1116 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_make_file_obj (self, file);
#line 1116 "../libdeja/duplicity/DuplicityJob.vala"
	gfile = _tmp0_;
#line 1117 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = gfile;
#line 1117 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1117 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 1117 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = _tmp2_;
#line 1118 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = gfile;
#line 1118 "../libdeja/duplicity/DuplicityJob.vala"
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 5954 "DuplicityJob.c"
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
#line 1119 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = gfile;
#line 1119 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->_state;
#line 1119 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
#line 5963 "DuplicityJob.c"
	}
#line 1115 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (gfile);
#line 5967 "DuplicityJob.c"
}

static void
duplicity_job_process_patch_file (DuplicityJob* self,
                                  const gchar* file)
{
	GFile* gfile = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
#line 1122 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1122 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (file != NULL);
#line 1123 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_make_file_obj (self, file);
#line 1123 "../libdeja/duplicity/DuplicityJob.vala"
	gfile = _tmp0_;
#line 1124 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = gfile;
#line 1124 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1124 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 1124 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = _tmp2_;
#line 1125 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = gfile;
#line 1125 "../libdeja/duplicity/DuplicityJob.vala"
	if (g_file_query_file_type (_tmp3_, G_FILE_QUERY_INFO_NONE, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 5999 "DuplicityJob.c"
		GFile* _tmp4_;
		DuplicityJobState _tmp5_;
#line 1126 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = gfile;
#line 1126 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->_state;
#line 1126 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_status_file (self, _tmp4_, _tmp5_ != DUPLICITY_JOB_STATE_DRY_RUN, TRUE);
#line 6008 "DuplicityJob.c"
	}
#line 1122 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (gfile);
#line 6012 "DuplicityJob.c"
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result;
#line 839 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 840 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 840 "glib-2.0.vapi"
	return result;
#line 6026 "DuplicityJob.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
#line 1003 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 1004 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 1004 "glib-2.0.vapi"
	return result;
#line 6039 "DuplicityJob.c"
}

static void
duplicity_job_process_progress (DuplicityJob* self,
                                gchar** firstline,
                                gint firstline_length1)
{
	gdouble total = 0.0;
	gdouble percent = 0.0;
#line 1129 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1133 "../libdeja/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 2) {
#line 6053 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1134 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[2];
#line 1134 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->progress_count = uint64_parse (_tmp0_, (guint) 0);
#line 6059 "DuplicityJob.c"
	} else {
#line 1136 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 6063 "DuplicityJob.c"
	}
#line 1138 "../libdeja/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 3) {
#line 6067 "DuplicityJob.c"
		const gchar* _tmp1_;
#line 1139 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = firstline[3];
#line 1139 "../libdeja/duplicity/DuplicityJob.vala"
		total = double_parse (_tmp1_);
#line 6073 "DuplicityJob.c"
	} else {
#line 1140 "../libdeja/duplicity/DuplicityJob.vala"
		if (self->priv->progress_total > ((guint64) 0)) {
#line 1141 "../libdeja/duplicity/DuplicityJob.vala"
			total = (gdouble) self->priv->progress_total;
#line 6079 "DuplicityJob.c"
		} else {
#line 1143 "../libdeja/duplicity/DuplicityJob.vala"
			return;
#line 6083 "DuplicityJob.c"
		}
	}
#line 1145 "../libdeja/duplicity/DuplicityJob.vala"
	percent = ((gdouble) self->priv->progress_count) / total;
#line 1146 "../libdeja/duplicity/DuplicityJob.vala"
	if (percent > ((gdouble) 1)) {
#line 1147 "../libdeja/duplicity/DuplicityJob.vala"
		percent = (gdouble) 1;
#line 6092 "DuplicityJob.c"
	}
#line 1148 "../libdeja/duplicity/DuplicityJob.vala"
	if (percent < ((gdouble) 0)) {
#line 1149 "../libdeja/duplicity/DuplicityJob.vala"
		percent = (gdouble) 0;
#line 6098 "DuplicityJob.c"
	}
#line 1150 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "progress", percent);
#line 6102 "DuplicityJob.c"
}

static GFile*
duplicity_job_make_file_obj (DuplicityJob* self,
                             const gchar* file)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* result;
#line 1153 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1153 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1157 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 1157 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 1157 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp1_ != NULL) {
#line 6124 "DuplicityJob.c"
		GFile* local_file = NULL;
		GList* _tmp2_;
		GList* _tmp3_;
		gconstpointer _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 1158 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp2_ = deja_dup_tool_job_get_restore_files ((DejaDupToolJob*) self);
#line 1158 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = _tmp2_;
#line 1158 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = _tmp3_->data;
#line 1158 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = duplicity_job_make_local_rel_path (self, (GFile*) _tmp4_);
#line 1158 "../libdeja/duplicity/DuplicityJob.vala"
		local_file = _tmp5_;
#line 1159 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp6_ = local_file;
#line 1159 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = g_file_resolve_relative_path (_tmp6_, file);
#line 1159 "../libdeja/duplicity/DuplicityJob.vala"
		result = _tmp7_;
#line 1159 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (local_file);
#line 1159 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 6152 "DuplicityJob.c"
	}
#line 1163 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp8_ = duplicity_job_slash;
#line 1163 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp9_ = g_file_resolve_relative_path (_tmp8_, file);
#line 1163 "../libdeja/duplicity/DuplicityJob.vala"
	result = _tmp9_;
#line 1163 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 6162 "DuplicityJob.c"
}

static gint
__lambda18_ (DuplicityJob* self,
             GDateTime* a,
             GDateTime* b)
{
	gint result;
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	result = g_date_time_compare (a, b);
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 6179 "DuplicityJob.c"
}

static gint
___lambda18__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda18_ ((DuplicityJob*) self, (GDateTime*) a, (GDateTime*) b);
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 6191 "DuplicityJob.c"
}

static void
_g_date_time_unref0_ (gpointer var)
{
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	(var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL));
#line 6199 "DuplicityJob.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 6223 "DuplicityJob.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 6231 "DuplicityJob.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 6237 "DuplicityJob.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 6255 "DuplicityJob.c"
}

static gpointer
_duplicity_job_date_info_dup0 (gpointer self)
{
#line 1203 "../libdeja/duplicity/DuplicityJob.vala"
	return self ? duplicity_job_date_info_dup (self) : NULL;
#line 6263 "DuplicityJob.c"
}

static void
duplicity_job_process_collection_status (DuplicityJob* self,
                                         GList* lines)
{
	gboolean _tmp0_ = FALSE;
	DejaDupToolJobMode _tmp1_;
	DejaDupToolJobMode _tmp2_;
	GTree* dates = NULL;
	GTree* _tmp3_;
	GList* infos = NULL;
	gboolean in_chain = FALSE;
	GList* _tmp42_;
	GTree* _tmp48_;
#line 1166 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = _tmp1_;
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp2_ != DEJA_DUP_TOOL_JOB_MODE_STATUS) {
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = TRUE;
#line 6289 "DuplicityJob.c"
	} else {
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = self->priv->got_collection_info;
#line 6293 "DuplicityJob.c"
	}
#line 1176 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_) {
#line 1177 "../libdeja/duplicity/DuplicityJob.vala"
		return;
#line 6299 "DuplicityJob.c"
	}
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp3_ = g_tree_new_full (___lambda18__gcompare_data_func, self, _g_date_time_unref0_, _g_free0_);
#line 1179 "../libdeja/duplicity/DuplicityJob.vala"
	dates = _tmp3_;
#line 1180 "../libdeja/duplicity/DuplicityJob.vala"
	infos = NULL;
#line 1181 "../libdeja/duplicity/DuplicityJob.vala"
	in_chain = FALSE;
#line 6309 "DuplicityJob.c"
	{
		GList* line_collection = NULL;
		GList* line_it = NULL;
#line 1182 "../libdeja/duplicity/DuplicityJob.vala"
		line_collection = lines;
#line 1182 "../libdeja/duplicity/DuplicityJob.vala"
		for (line_it = line_collection; line_it != NULL; line_it = line_it->next) {
#line 6317 "DuplicityJob.c"
			gchar* _tmp4_;
			gchar* line = NULL;
#line 1182 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp4_ = g_strdup ((const gchar*) line_it->data);
#line 1182 "../libdeja/duplicity/DuplicityJob.vala"
			line = _tmp4_;
#line 6324 "DuplicityJob.c"
			{
				gboolean _tmp5_ = FALSE;
				const gchar* _tmp6_;
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp6_ = line;
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
				if (g_strcmp0 (_tmp6_, "chain-complete") == 0) {
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = TRUE;
#line 6334 "DuplicityJob.c"
				} else {
					const gchar* _tmp7_;
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp7_ = line;
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = string_index_of (_tmp7_, "chain-no-sig", 0) == 0;
#line 6341 "DuplicityJob.c"
				}
#line 1183 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp5_) {
#line 1184 "../libdeja/duplicity/DuplicityJob.vala"
					in_chain = TRUE;
#line 6347 "DuplicityJob.c"
				} else {
					gboolean _tmp8_ = FALSE;
					gboolean _tmp9_ = FALSE;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
					if (in_chain) {
#line 6353 "DuplicityJob.c"
						const gchar* _tmp10_;
						gint _tmp11_;
						gint _tmp12_;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp10_ = line;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp11_ = strlen (_tmp10_);
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp12_ = _tmp11_;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp9_ = _tmp12_ > 0;
#line 6365 "DuplicityJob.c"
					} else {
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp9_ = FALSE;
#line 6369 "DuplicityJob.c"
					}
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp9_) {
#line 6373 "DuplicityJob.c"
						const gchar* _tmp13_;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp13_ = line;
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp8_ = string_get (_tmp13_, (glong) 0) == ' ';
#line 6379 "DuplicityJob.c"
					} else {
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp8_ = FALSE;
#line 6383 "DuplicityJob.c"
					}
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp8_) {
#line 6387 "DuplicityJob.c"
						gchar** tokens = NULL;
						const gchar* _tmp14_;
						gchar** _tmp15_;
						gchar** _tmp16_;
						gint tokens_length1;
						gint _tokens_size_;
						gchar** _tmp17_;
						gint _tmp17__length1;
						GDateTime* datetime = NULL;
						gchar** _tmp18_;
						gint _tmp18__length1;
						const gchar* _tmp19_;
						GTimeZone* _tmp20_;
						GTimeZone* _tmp21_;
						GDateTime* _tmp22_;
						GDateTime* _tmp23_;
						GDateTime* _tmp24_;
						GTree* _tmp25_;
						GDateTime* _tmp26_;
						GDateTime* _tmp27_;
						gchar** _tmp28_;
						gint _tmp28__length1;
						const gchar* _tmp29_;
						gchar* _tmp30_;
						DuplicityJobDateInfo info = {0};
						GDateTime* _tmp31_;
						GDateTime* _tmp32_;
						gchar** _tmp33_;
						gint _tmp33__length1;
						const gchar* _tmp34_;
						DuplicityJobDateInfo _tmp35_;
						DuplicityJobDateInfo _tmp36_;
						DuplicityJobDateInfo* _tmp37_;
						gboolean _tmp38_ = FALSE;
#line 1190 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp14_ = line;
#line 1190 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, " ", 0);
#line 1190 "../libdeja/duplicity/DuplicityJob.vala"
						tokens = _tmp16_;
#line 1190 "../libdeja/duplicity/DuplicityJob.vala"
						tokens_length1 = _vala_array_length (_tmp15_);
#line 1190 "../libdeja/duplicity/DuplicityJob.vala"
						_tokens_size_ = tokens_length1;
#line 1191 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp17_ = tokens;
#line 1191 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp17__length1 = tokens_length1;
#line 1191 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp17__length1 <= 2) {
#line 1192 "../libdeja/duplicity/DuplicityJob.vala"
							tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 1192 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (line);
#line 1192 "../libdeja/duplicity/DuplicityJob.vala"
							continue;
#line 6444 "DuplicityJob.c"
						}
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp18_ = tokens;
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp18__length1 = tokens_length1;
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp19_ = _tmp18_[2];
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp20_ = g_time_zone_new_utc ();
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp21_ = _tmp20_;
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp22_ = g_date_time_new_from_iso8601 (_tmp19_, _tmp21_);
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp23_ = _tmp22_;
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						_g_time_zone_unref0 (_tmp21_);
#line 1194 "../libdeja/duplicity/DuplicityJob.vala"
						datetime = _tmp23_;
#line 1195 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp24_ = datetime;
#line 1195 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp24_ == NULL) {
#line 1196 "../libdeja/duplicity/DuplicityJob.vala"
							_g_date_time_unref0 (datetime);
#line 1196 "../libdeja/duplicity/DuplicityJob.vala"
							tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 1196 "../libdeja/duplicity/DuplicityJob.vala"
							_g_free0 (line);
#line 1196 "../libdeja/duplicity/DuplicityJob.vala"
							continue;
#line 6476 "DuplicityJob.c"
						}
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp25_ = dates;
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp26_ = datetime;
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp27_ = _g_date_time_ref0 (_tmp26_);
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp28_ = tokens;
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp28__length1 = tokens_length1;
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp29_ = _tmp28_[2];
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp30_ = g_strdup (_tmp29_);
#line 1198 "../libdeja/duplicity/DuplicityJob.vala"
						g_tree_insert (_tmp25_, _tmp27_, _tmp30_);
#line 1200 "../libdeja/duplicity/DuplicityJob.vala"
						memset (&info, 0, sizeof (DuplicityJobDateInfo));
#line 1201 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp31_ = datetime;
#line 1201 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp32_ = _g_date_time_ref0 (_tmp31_);
#line 1201 "../libdeja/duplicity/DuplicityJob.vala"
						_g_date_time_unref0 (info.time);
#line 1201 "../libdeja/duplicity/DuplicityJob.vala"
						info.time = _tmp32_;
#line 1202 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp33_ = tokens;
#line 1202 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp33__length1 = tokens_length1;
#line 1202 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp34_ = _tmp33_[1];
#line 1202 "../libdeja/duplicity/DuplicityJob.vala"
						info.full = g_strcmp0 (_tmp34_, "full") == 0;
#line 1203 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp35_ = info;
#line 1203 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp36_ = _tmp35_;
#line 1203 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp37_ = _duplicity_job_date_info_dup0 (&_tmp36_);
#line 1203 "../libdeja/duplicity/DuplicityJob.vala"
						infos = g_list_append (infos, _tmp37_);
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
						if (!self->priv->detected_encryption) {
#line 6522 "DuplicityJob.c"
							gchar** _tmp39_;
							gint _tmp39__length1;
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp39_ = tokens;
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp39__length1 = tokens_length1;
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp38_ = _tmp39__length1 > 4;
#line 6531 "DuplicityJob.c"
						} else {
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp38_ = FALSE;
#line 6535 "DuplicityJob.c"
						}
#line 1205 "../libdeja/duplicity/DuplicityJob.vala"
						if (_tmp38_) {
#line 6539 "DuplicityJob.c"
							gchar** _tmp40_;
							gint _tmp40__length1;
							const gchar* _tmp41_;
#line 1208 "../libdeja/duplicity/DuplicityJob.vala"
							self->priv->detected_encryption = TRUE;
#line 1209 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp40_ = tokens;
#line 1209 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp40__length1 = tokens_length1;
#line 1209 "../libdeja/duplicity/DuplicityJob.vala"
							_tmp41_ = _tmp40_[4];
#line 1209 "../libdeja/duplicity/DuplicityJob.vala"
							self->priv->existing_encrypted = g_strcmp0 (_tmp41_, "enc") == 0;
#line 6553 "DuplicityJob.c"
						}
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						duplicity_job_date_info_destroy (&info);
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						_g_date_time_unref0 (datetime);
#line 1185 "../libdeja/duplicity/DuplicityJob.vala"
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 6561 "DuplicityJob.c"
					} else {
#line 1212 "../libdeja/duplicity/DuplicityJob.vala"
						if (in_chain) {
#line 1213 "../libdeja/duplicity/DuplicityJob.vala"
							in_chain = FALSE;
#line 6567 "DuplicityJob.c"
						}
					}
				}
#line 1182 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (line);
#line 6573 "DuplicityJob.c"
			}
		}
	}
#line 1216 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->got_collection_info = TRUE;
#line 1217 "../libdeja/duplicity/DuplicityJob.vala"
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
#line 1217 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->collection_info = NULL;
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp42_ = infos;
#line 6585 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
		s_collection = _tmp42_;
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 6593 "DuplicityJob.c"
			DuplicityJobDateInfo _tmp43_;
			DuplicityJobDateInfo _tmp44_ = {0};
			DuplicityJobDateInfo s = {0};
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp43_ = *((DuplicityJobDateInfo*) s_it->data);
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
			duplicity_job_date_info_copy (&_tmp43_, &_tmp44_);
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
			s = _tmp44_;
#line 6603 "DuplicityJob.c"
			{
				DuplicityJobDateInfo _tmp45_;
				DuplicityJobDateInfo _tmp46_;
				DuplicityJobDateInfo* _tmp47_;
#line 1219 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp45_ = s;
#line 1219 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp46_ = _tmp45_;
#line 1219 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp47_ = _duplicity_job_date_info_dup0 (&_tmp46_);
#line 1219 "../libdeja/duplicity/DuplicityJob.vala"
				self->priv->collection_info = g_list_append (self->priv->collection_info, _tmp47_);
#line 1218 "../libdeja/duplicity/DuplicityJob.vala"
				duplicity_job_date_info_destroy (&s);
#line 6618 "DuplicityJob.c"
			}
		}
	}
#line 1221 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp48_ = dates;
#line 1221 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_emit_by_name ((DejaDupToolJob*) self, "collection-dates", _tmp48_);
#line 1166 "../libdeja/duplicity/DuplicityJob.vala"
	(infos == NULL) ? NULL : (infos = (_g_list_free__duplicity_job_date_info_free0_ (infos), NULL));
#line 1166 "../libdeja/duplicity/DuplicityJob.vala"
	_g_tree_unref0 (dates);
#line 6630 "DuplicityJob.c"
}

static gboolean
duplicity_job_is_file_in_list (DuplicityJob* self,
                               GFile* file,
                               GList* list)
{
	gboolean result;
#line 1224 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1224 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 6643 "DuplicityJob.c"
	{
		GList* f_collection = NULL;
		GList* f_it = NULL;
#line 1226 "../libdeja/duplicity/DuplicityJob.vala"
		f_collection = list;
#line 1226 "../libdeja/duplicity/DuplicityJob.vala"
		for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 6651 "DuplicityJob.c"
			GFile* _tmp0_;
			GFile* f = NULL;
#line 1226 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp0_ = _g_object_ref0 ((GFile*) f_it->data);
#line 1226 "../libdeja/duplicity/DuplicityJob.vala"
			f = _tmp0_;
#line 6658 "DuplicityJob.c"
			{
				GFile* _tmp1_;
#line 1227 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp1_ = f;
#line 1227 "../libdeja/duplicity/DuplicityJob.vala"
				if (g_file_equal (file, _tmp1_)) {
#line 1228 "../libdeja/duplicity/DuplicityJob.vala"
					result = TRUE;
#line 1228 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (f);
#line 1228 "../libdeja/duplicity/DuplicityJob.vala"
					return result;
#line 6671 "DuplicityJob.c"
				}
#line 1226 "../libdeja/duplicity/DuplicityJob.vala"
				_g_object_unref0 (f);
#line 6675 "DuplicityJob.c"
			}
		}
	}
#line 1230 "../libdeja/duplicity/DuplicityJob.vala"
	result = FALSE;
#line 1230 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 6683 "DuplicityJob.c"
}

static gboolean
duplicity_job_is_file_in_or_under_list (DuplicityJob* self,
                                        GFile* file,
                                        GList* list)
{
	gboolean result;
#line 1233 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1233 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 6696 "DuplicityJob.c"
	{
		GList* f_collection = NULL;
		GList* f_it = NULL;
#line 1235 "../libdeja/duplicity/DuplicityJob.vala"
		f_collection = list;
#line 1235 "../libdeja/duplicity/DuplicityJob.vala"
		for (f_it = f_collection; f_it != NULL; f_it = f_it->next) {
#line 6704 "DuplicityJob.c"
			GFile* _tmp0_;
			GFile* f = NULL;
#line 1235 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp0_ = _g_object_ref0 ((GFile*) f_it->data);
#line 1235 "../libdeja/duplicity/DuplicityJob.vala"
			f = _tmp0_;
#line 6711 "DuplicityJob.c"
			{
				gboolean _tmp1_ = FALSE;
				GFile* _tmp2_;
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = f;
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
				if (g_file_equal (file, _tmp2_)) {
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp1_ = TRUE;
#line 6721 "DuplicityJob.c"
				} else {
					GFile* _tmp3_;
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp3_ = f;
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp1_ = g_file_has_prefix (file, _tmp3_);
#line 6728 "DuplicityJob.c"
				}
#line 1236 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp1_) {
#line 1237 "../libdeja/duplicity/DuplicityJob.vala"
					result = TRUE;
#line 1237 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (f);
#line 1237 "../libdeja/duplicity/DuplicityJob.vala"
					return result;
#line 6738 "DuplicityJob.c"
				}
#line 1235 "../libdeja/duplicity/DuplicityJob.vala"
				_g_object_unref0 (f);
#line 6742 "DuplicityJob.c"
			}
		}
	}
#line 1239 "../libdeja/duplicity/DuplicityJob.vala"
	result = FALSE;
#line 1239 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 6750 "DuplicityJob.c"
}

static void
duplicity_job_real_process_warning (DuplicityJob* self,
                                    gchar** firstline,
                                    gint firstline_length1,
                                    GList* data,
                                    const gchar* text)
{
#line 1242 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (text != NULL);
#line 1245 "../libdeja/duplicity/DuplicityJob.vala"
	if (firstline_length1 > 1) {
#line 6764 "DuplicityJob.c"
		const gchar* _tmp0_;
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp0_ = firstline[1];
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
		switch (atoi (_tmp0_)) {
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_ORPHANED_SIG:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_UNNECESSARY_SIG:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_UNMATCHED_SIG:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_INCOMPLETE_BACKUP:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_ORPHANED_BACKUP:
#line 6780 "DuplicityJob.c"
			{
				gboolean _tmp1_ = FALSE;
				DejaDupToolJobMode _tmp2_;
				DejaDupToolJobMode _tmp3_;
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp2_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp3_ = _tmp2_;
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp3_ == DEJA_DUP_TOOL_JOB_MODE_BACKUP) {
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp1_ = !self->priv->cleaned_up_once;
#line 6793 "DuplicityJob.c"
				} else {
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp1_ = FALSE;
#line 6797 "DuplicityJob.c"
				}
#line 1256 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp1_) {
#line 1257 "../libdeja/duplicity/DuplicityJob.vala"
					duplicity_job_cleanup (self);
#line 6803 "DuplicityJob.c"
				}
#line 1258 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 6807 "DuplicityJob.c"
			}
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_CANNOT_STAT:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_CANNOT_READ:
#line 6813 "DuplicityJob.c"
			{
#line 1264 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 6817 "DuplicityJob.c"
					GFile* error_file = NULL;
					const gchar* _tmp4_;
					GFile* _tmp5_;
					gboolean _tmp6_ = FALSE;
					GFile* _tmp7_;
					GList* _tmp8_;
#line 1271 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp4_ = firstline[2];
#line 1271 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp5_ = duplicity_job_make_file_obj (self, _tmp4_);
#line 1271 "../libdeja/duplicity/DuplicityJob.vala"
					error_file = _tmp5_;
#line 1272 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp7_ = error_file;
#line 1272 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp8_ = ((DejaDupToolJob*) self)->includes;
#line 1272 "../libdeja/duplicity/DuplicityJob.vala"
					if (duplicity_job_is_file_in_or_under_list (self, _tmp7_, _tmp8_)) {
#line 6836 "DuplicityJob.c"
						GFile* _tmp9_;
						GList* _tmp10_;
#line 1273 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp9_ = error_file;
#line 1273 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp10_ = ((DejaDupToolJob*) self)->excludes;
#line 1273 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp6_ = !duplicity_job_is_file_in_list (self, _tmp9_, _tmp10_);
#line 6845 "DuplicityJob.c"
					} else {
#line 1272 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp6_ = FALSE;
#line 6849 "DuplicityJob.c"
					}
#line 1272 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp6_) {
#line 6853 "DuplicityJob.c"
						GFile* _tmp11_;
						gchar* _tmp12_;
						gchar* _tmp13_;
#line 1274 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp11_ = error_file;
#line 1274 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp12_ = g_file_get_parse_name (_tmp11_);
#line 1274 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp13_ = _tmp12_;
#line 1274 "../libdeja/duplicity/DuplicityJob.vala"
						g_signal_emit_by_name ((DejaDupToolJob*) self, "local-file-error", _tmp13_);
#line 1274 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (_tmp13_);
#line 6867 "DuplicityJob.c"
					}
#line 1264 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (error_file);
#line 6871 "DuplicityJob.c"
				}
#line 1276 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 6875 "DuplicityJob.c"
			}
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			case DUPLICITY_JOB_WARNING_CANNOT_PROCESS:
#line 6879 "DuplicityJob.c"
			{
#line 1281 "../libdeja/duplicity/DuplicityJob.vala"
				if (firstline_length1 > 2) {
#line 6883 "DuplicityJob.c"
					GFile* error_file = NULL;
					const gchar* _tmp14_;
					GFile* _tmp15_;
					gboolean _tmp16_ = FALSE;
					GFile* _tmp17_;
					GFile* _tmp18_;
#line 1285 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp14_ = firstline[2];
#line 1285 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp15_ = duplicity_job_make_file_obj (self, _tmp14_);
#line 1285 "../libdeja/duplicity/DuplicityJob.vala"
					error_file = _tmp15_;
#line 1286 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp17_ = error_file;
#line 1286 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp18_ = duplicity_job_slash;
#line 1286 "../libdeja/duplicity/DuplicityJob.vala"
					if (!g_file_equal (_tmp17_, _tmp18_)) {
#line 1287 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp16_ = !string_contains (text, "[Errno 1]");
#line 6904 "DuplicityJob.c"
					} else {
#line 1286 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp16_ = FALSE;
#line 6908 "DuplicityJob.c"
					}
#line 1286 "../libdeja/duplicity/DuplicityJob.vala"
					if (_tmp16_) {
#line 6912 "DuplicityJob.c"
						GFile* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
#line 1288 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp19_ = error_file;
#line 1288 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp20_ = g_file_get_parse_name (_tmp19_);
#line 1288 "../libdeja/duplicity/DuplicityJob.vala"
						_tmp21_ = _tmp20_;
#line 1288 "../libdeja/duplicity/DuplicityJob.vala"
						g_signal_emit_by_name ((DejaDupToolJob*) self, "local-file-error", _tmp21_);
#line 1288 "../libdeja/duplicity/DuplicityJob.vala"
						_g_free0 (_tmp21_);
#line 6926 "DuplicityJob.c"
					}
#line 1281 "../libdeja/duplicity/DuplicityJob.vala"
					_g_object_unref0 (error_file);
#line 6930 "DuplicityJob.c"
				}
#line 1290 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 6934 "DuplicityJob.c"
			}
			default:
#line 1246 "../libdeja/duplicity/DuplicityJob.vala"
			break;
#line 6939 "DuplicityJob.c"
		}
	}
}

void
duplicity_job_process_warning (DuplicityJob* self,
                               gchar** firstline,
                               gint firstline_length1,
                               GList* data,
                               const gchar* text)
{
	DuplicityJobClass* _klass_;
#line 1242 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1242 "../libdeja/duplicity/DuplicityJob.vala"
	_klass_ = DUPLICITY_JOB_GET_CLASS (self);
#line 1242 "../libdeja/duplicity/DuplicityJob.vala"
	if (_klass_->process_warning) {
#line 1242 "../libdeja/duplicity/DuplicityJob.vala"
		_klass_->process_warning (self, firstline, firstline_length1, data, text);
#line 6960 "DuplicityJob.c"
	}
}

static void
duplicity_job_show_error (DuplicityJob* self,
                          const gchar* errorstr,
                          const gchar* detail)
{
	gboolean _tmp0_;
#line 1295 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1295 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (errorstr != NULL);
#line 1297 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->_error_issued;
#line 1297 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ == FALSE) {
#line 1298 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_error_issued (self, TRUE);
#line 1299 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_emit_by_name ((DejaDupToolJob*) self, "raise-error", errorstr, detail);
#line 6982 "DuplicityJob.c"
	}
}

static gint
duplicity_job_get_volsize (DuplicityJob* self)
{
	gint result;
#line 1304 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1324 "../libdeja/duplicity/DuplicityJob.vala"
	if (deja_dup_in_testing_mode ()) {
#line 1325 "../libdeja/duplicity/DuplicityJob.vala"
		result = 1;
#line 1325 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 6998 "DuplicityJob.c"
	} else {
#line 1327 "../libdeja/duplicity/DuplicityJob.vala"
		result = 200;
#line 1327 "../libdeja/duplicity/DuplicityJob.vala"
		return result;
#line 7004 "DuplicityJob.c"
	}
}

static void
_duplicity_job_handle_done_duplicity_instance_done (DuplicityInstance* _sender,
                                                    gboolean success,
                                                    gboolean cancelled,
                                                    gpointer self)
{
#line 1334 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_handle_done ((DuplicityJob*) self, _sender, success, cancelled);
#line 7016 "DuplicityJob.c"
}

static void
_duplicity_job_handle_message_duplicity_instance_message (DuplicityInstance* _sender,
                                                          gchar** control_line,
                                                          gint control_line_length1,
                                                          GList* data_lines,
                                                          const gchar* user_text,
                                                          gpointer self)
{
#line 1335 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_handle_message ((DuplicityJob*) self, _sender, control_line, control_line_length1, data_lines, user_text);
#line 7029 "DuplicityJob.c"
}

static void
_duplicity_job_handle_exit_duplicity_instance_exited (DuplicityInstance* _sender,
                                                      gint code,
                                                      gpointer self)
{
#line 1336 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_handle_exit ((DuplicityJob*) self, code);
#line 7039 "DuplicityJob.c"
}

static void
duplicity_job_disconnect_inst (DuplicityJob* self)
{
	DuplicityInstance* _tmp0_;
#line 1330 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1333 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = self->priv->inst;
#line 1333 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ != NULL) {
#line 7052 "DuplicityJob.c"
		DuplicityInstance* _tmp1_;
		guint _tmp2_;
		DuplicityInstance* _tmp3_;
		guint _tmp4_;
		DuplicityInstance* _tmp5_;
		guint _tmp6_;
		DuplicityInstance* _tmp7_;
#line 1334 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = self->priv->inst;
#line 1334 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("done", TYPE_DUPLICITY_INSTANCE, &_tmp2_, NULL, FALSE);
#line 1334 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self);
#line 1335 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = self->priv->inst;
#line 1335 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("message", TYPE_DUPLICITY_INSTANCE, &_tmp4_, NULL, FALSE);
#line 1335 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self);
#line 1336 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp5_ = self->priv->inst;
#line 1336 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_parse_name ("exited", TYPE_DUPLICITY_INSTANCE, &_tmp6_, NULL, FALSE);
#line 1336 "../libdeja/duplicity/DuplicityJob.vala"
		g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self);
#line 1337 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = self->priv->inst;
#line 1337 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_instance_cancel (_tmp7_);
#line 1338 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (self->priv->inst);
#line 1338 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->inst = NULL;
#line 7086 "DuplicityJob.c"
	}
}

static void
duplicity_job_connect_and_start (DuplicityJob* self,
                                 GList* argv_extra,
                                 GList* envp_extra,
                                 GList* argv_entire,
                                 GFile* custom_local)
{
	DuplicityInstance* _tmp0_;
	DuplicityInstance* _tmp1_;
	const gchar* _tmp2_;
	DuplicityInstance* _tmp5_;
	DuplicityInstance* _tmp6_;
	GList* _tmp7_ = NULL;
	GList* base_argv = NULL;
	GFile* _tmp9_ = NULL;
	GFile* local_arg = NULL;
	GList* argv = NULL;
	GList* _tmp12_;
	GList* envp = NULL;
	GList* _tmp52_;
	gboolean use_encryption = FALSE;
	DuplicityInstance* _tmp73_;
	GList* _tmp74_;
	GList* _tmp75_;
#line 1342 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 1351 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_disconnect_inst (self);
#line 1354 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_instance_new ();
#line 1354 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->inst);
#line 1354 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->inst = _tmp0_;
#line 1355 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = self->priv->inst;
#line 1355 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp1_, "done", (GCallback) _duplicity_job_handle_done_duplicity_instance_done, self, 0);
#line 1357 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp2_ = self->priv->forced_cache_dir;
#line 1357 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp2_ != NULL) {
#line 7132 "DuplicityJob.c"
		DuplicityInstance* _tmp3_;
		const gchar* _tmp4_;
#line 1358 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp3_ = self->priv->inst;
#line 1358 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp4_ = self->priv->forced_cache_dir;
#line 1358 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_instance_set_forced_cache_dir (_tmp3_, _tmp4_);
#line 7141 "DuplicityJob.c"
	}
#line 1361 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp5_ = self->priv->inst;
#line 1361 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp5_, "message", (GCallback) _duplicity_job_handle_message_duplicity_instance_message, self, 0);
#line 1364 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp6_ = self->priv->inst;
#line 1364 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_connect_object (_tmp6_, "exited", (GCallback) _duplicity_job_handle_exit_duplicity_instance_exited, self, 0);
#line 1367 "../libdeja/duplicity/DuplicityJob.vala"
	if (argv_entire == NULL) {
#line 7153 "DuplicityJob.c"
		GList* _tmp8_;
#line 1367 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp8_ = self->priv->saved_argv;
#line 1367 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = _tmp8_;
#line 7159 "DuplicityJob.c"
	} else {
#line 1367 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp7_ = argv_entire;
#line 7163 "DuplicityJob.c"
	}
#line 1367 "../libdeja/duplicity/DuplicityJob.vala"
	base_argv = _tmp7_;
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
	if (custom_local == NULL) {
#line 7169 "DuplicityJob.c"
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp10_ = deja_dup_tool_job_get_local ((DejaDupToolJob*) self);
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp11_ = _tmp10_;
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp9_ = _tmp11_;
#line 7178 "DuplicityJob.c"
	} else {
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp9_ = custom_local;
#line 7182 "DuplicityJob.c"
	}
#line 1368 "../libdeja/duplicity/DuplicityJob.vala"
	local_arg = _tmp9_;
#line 1370 "../libdeja/duplicity/DuplicityJob.vala"
	argv = NULL;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp12_ = base_argv;
#line 7190 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
		s_collection = _tmp12_;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7198 "DuplicityJob.c"
			gchar* _tmp13_;
			gchar* s = NULL;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp13_ = g_strdup ((const gchar*) s_it->data);
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
			s = _tmp13_;
#line 7205 "DuplicityJob.c"
			{
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp14_ = s;
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp15_);
#line 1371 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7217 "DuplicityJob.c"
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
		s_collection = argv_extra;
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7228 "DuplicityJob.c"
			gchar* _tmp16_;
			gchar* s = NULL;
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp16_ = g_strdup ((const gchar*) s_it->data);
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
			s = _tmp16_;
#line 7235 "DuplicityJob.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp17_ = s;
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp18_ = g_strdup (_tmp17_);
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp18_);
#line 1372 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7247 "DuplicityJob.c"
			}
		}
	}
#line 1375 "../libdeja/duplicity/DuplicityJob.vala"
	if (argv_entire == NULL) {
#line 7253 "DuplicityJob.c"
		DejaDupToolJobMode _tmp19_;
		DejaDupToolJobMode _tmp20_;
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp19_ = deja_dup_tool_job_get_mode ((DejaDupToolJob*) self);
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp20_ = _tmp19_;
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
		switch (_tmp20_) {
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_BACKUP:
#line 7264 "DuplicityJob.c"
			{
				gchar* _tmp22_;
				GFile* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 1379 "../libdeja/duplicity/DuplicityJob.vala"
				if (self->priv->is_full_backup) {
#line 7272 "DuplicityJob.c"
					gchar* _tmp21_;
#line 1380 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp21_ = g_strdup ("full");
#line 1380 "../libdeja/duplicity/DuplicityJob.vala"
					argv = g_list_prepend (argv, _tmp21_);
#line 7278 "DuplicityJob.c"
				}
#line 1381 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp22_ = g_strdup_printf ("--volsize=%d", duplicity_job_get_volsize (self));
#line 1381 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp22_);
#line 1382 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp23_ = local_arg;
#line 1382 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp24_ = g_file_get_path (_tmp23_);
#line 1382 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp24_);
#line 1383 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp25_ = duplicity_job_get_remote (self);
#line 1383 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp25_);
#line 1384 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 7296 "DuplicityJob.c"
			}
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_RESTORE:
#line 7300 "DuplicityJob.c"
			{
				gchar* _tmp26_;
				gboolean _tmp27_ = FALSE;
				const gchar* _tmp28_;
				const gchar* _tmp29_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				GFile* _tmp38_;
				gchar* _tmp39_;
#line 1386 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp26_ = g_strdup ("restore");
#line 1386 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp26_);
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp28_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp29_ = _tmp28_;
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp29_ != NULL) {
#line 7321 "DuplicityJob.c"
					const gchar* _tmp30_;
					const gchar* _tmp31_;
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp30_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp31_ = _tmp30_;
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp27_ = g_strcmp0 (_tmp31_, "now") != 0;
#line 7330 "DuplicityJob.c"
				} else {
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp27_ = FALSE;
#line 7334 "DuplicityJob.c"
				}
#line 1387 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp27_) {
#line 7338 "DuplicityJob.c"
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					gchar* _tmp34_;
#line 1388 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp32_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1388 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp33_ = _tmp32_;
#line 1388 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp34_ = g_strdup_printf ("--time=%s", _tmp33_);
#line 1388 "../libdeja/duplicity/DuplicityJob.vala"
					argv = g_list_append (argv, _tmp34_);
#line 7350 "DuplicityJob.c"
				}
#line 1392 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp35_ = g_strdup ("--do-not-restore-ownership");
#line 1392 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp35_);
#line 1393 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp36_ = g_strdup ("--force");
#line 1393 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp36_);
#line 1394 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp37_ = duplicity_job_get_remote (self);
#line 1394 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp37_);
#line 1395 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp38_ = local_arg;
#line 1395 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp39_ = g_file_get_path (_tmp38_);
#line 1395 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp39_);
#line 1396 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 7372 "DuplicityJob.c"
			}
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_STATUS:
#line 7376 "DuplicityJob.c"
			{
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 1398 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp40_ = g_strdup ("collection-status");
#line 1398 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp40_);
#line 1399 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp41_ = duplicity_job_get_remote (self);
#line 1399 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp41_);
#line 1400 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 7390 "DuplicityJob.c"
			}
#line 1377 "../libdeja/duplicity/DuplicityJob.vala"
			case DEJA_DUP_TOOL_JOB_MODE_LIST:
#line 7394 "DuplicityJob.c"
			{
				gchar* _tmp42_;
				gboolean _tmp43_ = FALSE;
				const gchar* _tmp44_;
				const gchar* _tmp45_;
				gchar* _tmp51_;
#line 1402 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp42_ = g_strdup ("list-current-files");
#line 1402 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_prepend (argv, _tmp42_);
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp44_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp45_ = _tmp44_;
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp45_ != NULL) {
#line 7411 "DuplicityJob.c"
					const gchar* _tmp46_;
					const gchar* _tmp47_;
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp46_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp47_ = _tmp46_;
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp43_ = g_strcmp0 (_tmp47_, "now") != 0;
#line 7420 "DuplicityJob.c"
				} else {
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp43_ = FALSE;
#line 7424 "DuplicityJob.c"
				}
#line 1403 "../libdeja/duplicity/DuplicityJob.vala"
				if (_tmp43_) {
#line 7428 "DuplicityJob.c"
					const gchar* _tmp48_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
#line 1404 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp48_ = deja_dup_tool_job_get_tag ((DejaDupToolJob*) self);
#line 1404 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp49_ = _tmp48_;
#line 1404 "../libdeja/duplicity/DuplicityJob.vala"
					_tmp50_ = g_strdup_printf ("--time=%s", _tmp49_);
#line 1404 "../libdeja/duplicity/DuplicityJob.vala"
					argv = g_list_append (argv, _tmp50_);
#line 7440 "DuplicityJob.c"
				}
#line 1405 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp51_ = duplicity_job_get_remote (self);
#line 1405 "../libdeja/duplicity/DuplicityJob.vala"
				argv = g_list_append (argv, _tmp51_);
#line 1406 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 7448 "DuplicityJob.c"
			}
			default:
			{
#line 1408 "../libdeja/duplicity/DuplicityJob.vala"
				break;
#line 7454 "DuplicityJob.c"
			}
		}
	}
#line 1413 "../libdeja/duplicity/DuplicityJob.vala"
	envp = NULL;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp52_ = self->priv->saved_envp;
#line 7462 "DuplicityJob.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
		s_collection = _tmp52_;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7470 "DuplicityJob.c"
			gchar* _tmp53_;
			gchar* s = NULL;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp53_ = g_strdup ((const gchar*) s_it->data);
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
			s = _tmp53_;
#line 7477 "DuplicityJob.c"
			{
				const gchar* _tmp54_;
				gchar* _tmp55_;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp54_ = s;
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp55_ = g_strdup (_tmp54_);
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
				envp = g_list_append (envp, _tmp55_);
#line 1414 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7489 "DuplicityJob.c"
			}
		}
	}
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
		s_collection = envp_extra;
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 7500 "DuplicityJob.c"
			gchar* _tmp56_;
			gchar* s = NULL;
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp56_ = g_strdup ((const gchar*) s_it->data);
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
			s = _tmp56_;
#line 7507 "DuplicityJob.c"
			{
				const gchar* _tmp57_;
				gchar* _tmp58_;
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp57_ = s;
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
				_tmp58_ = g_strdup (_tmp57_);
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
				envp = g_list_append (envp, _tmp58_);
#line 1415 "../libdeja/duplicity/DuplicityJob.vala"
				_g_free0 (s);
#line 7519 "DuplicityJob.c"
			}
		}
	}
#line 1417 "../libdeja/duplicity/DuplicityJob.vala"
	use_encryption = FALSE;
#line 1418 "../libdeja/duplicity/DuplicityJob.vala"
	if (self->priv->detected_encryption) {
#line 1419 "../libdeja/duplicity/DuplicityJob.vala"
		use_encryption = self->priv->existing_encrypted;
#line 7529 "DuplicityJob.c"
	} else {
		const gchar* _tmp59_;
		const gchar* _tmp60_;
#line 1420 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp59_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1420 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp60_ = _tmp59_;
#line 1420 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp60_ != NULL) {
#line 7539 "DuplicityJob.c"
			const gchar* _tmp61_;
			const gchar* _tmp62_;
#line 1421 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp61_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1421 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp62_ = _tmp61_;
#line 1421 "../libdeja/duplicity/DuplicityJob.vala"
			use_encryption = g_strcmp0 (_tmp62_, "") != 0;
#line 7548 "DuplicityJob.c"
		}
	}
#line 1423 "../libdeja/duplicity/DuplicityJob.vala"
	if (use_encryption) {
#line 7553 "DuplicityJob.c"
		gboolean _tmp63_ = FALSE;
		const gchar* _tmp64_;
		const gchar* _tmp65_;
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp64_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp65_ = _tmp64_;
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp65_ != NULL) {
#line 7563 "DuplicityJob.c"
			const gchar* _tmp66_;
			const gchar* _tmp67_;
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp66_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp67_ = _tmp66_;
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp63_ = g_strcmp0 (_tmp67_, "") != 0;
#line 7572 "DuplicityJob.c"
		} else {
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp63_ = FALSE;
#line 7576 "DuplicityJob.c"
		}
#line 1424 "../libdeja/duplicity/DuplicityJob.vala"
		if (_tmp63_) {
#line 7580 "DuplicityJob.c"
			const gchar* _tmp68_;
			const gchar* _tmp69_;
			gchar* _tmp70_;
#line 1425 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp68_ = deja_dup_tool_job_get_encrypt_password ((DejaDupToolJob*) self);
#line 1425 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp69_ = _tmp68_;
#line 1425 "../libdeja/duplicity/DuplicityJob.vala"
			_tmp70_ = g_strdup_printf ("PASSPHRASE=%s", _tmp69_);
#line 1425 "../libdeja/duplicity/DuplicityJob.vala"
			envp = g_list_append (envp, _tmp70_);
#line 7592 "DuplicityJob.c"
		}
	} else {
		gchar* _tmp71_;
		gchar* _tmp72_;
#line 1432 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp71_ = g_strdup ("--no-encryption");
#line 1432 "../libdeja/duplicity/DuplicityJob.vala"
		argv = g_list_append (argv, _tmp71_);
#line 1433 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp72_ = g_strdup ("PASSPHRASE=");
#line 1433 "../libdeja/duplicity/DuplicityJob.vala"
		envp = g_list_append (envp, _tmp72_);
#line 7605 "DuplicityJob.c"
	}
#line 1437 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp73_ = self->priv->inst;
#line 1437 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp74_ = argv;
#line 1437 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp75_ = envp;
#line 1437 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_instance_start (_tmp73_, _tmp74_, _tmp75_, NULL, NULL);
#line 1342 "../libdeja/duplicity/DuplicityJob.vala"
	(envp == NULL) ? NULL : (envp = (_g_list_free__g_free0_ (envp), NULL));
#line 1342 "../libdeja/duplicity/DuplicityJob.vala"
	(argv == NULL) ? NULL : (argv = (_g_list_free__g_free0_ (argv), NULL));
#line 7619 "DuplicityJob.c"
}

DuplicityJob*
duplicity_job_construct (GType object_type)
{
	DuplicityJob * self = NULL;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	self = (DuplicityJob*) deja_dup_tool_job_construct (object_type);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	return self;
#line 7630 "DuplicityJob.c"
}

DuplicityJob*
duplicity_job_new (void)
{
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	return duplicity_job_construct (TYPE_DUPLICITY_JOB);
#line 7638 "DuplicityJob.c"
}

static DejaDupToolJobMode
duplicity_job_get_original_mode (DuplicityJob* self)
{
	DejaDupToolJobMode result;
#line 11 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 11 "../libdeja/duplicity/DuplicityJob.vala"
	result = self->priv->_original_mode;
#line 11 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 7651 "DuplicityJob.c"
}

static void
duplicity_job_set_original_mode (DuplicityJob* self,
                                 DejaDupToolJobMode value)
{
#line 11 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 11 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->_original_mode = value;
#line 7662 "DuplicityJob.c"
}

static gboolean
duplicity_job_get_error_issued (DuplicityJob* self)
{
	gboolean result;
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	result = self->priv->_error_issued;
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 7675 "DuplicityJob.c"
}

static void
duplicity_job_set_error_issued (DuplicityJob* self,
                                gboolean value)
{
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->_error_issued = value;
#line 7686 "DuplicityJob.c"
}

static gboolean
duplicity_job_get_was_stopped (DuplicityJob* self)
{
	gboolean result;
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	result = self->priv->_was_stopped;
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 7699 "DuplicityJob.c"
}

static void
duplicity_job_set_was_stopped (DuplicityJob* self,
                               gboolean value)
{
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->_was_stopped = value;
#line 7710 "DuplicityJob.c"
}

DuplicityJobState
duplicity_job_get_state (DuplicityJob* self)
{
	DuplicityJobState result;
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	result = self->priv->_state;
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	return result;
#line 7723 "DuplicityJob.c"
}

void
duplicity_job_set_state (DuplicityJob* self,
                         DuplicityJobState value)
{
	DuplicityJobState old_value;
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	g_return_if_fail (self != NULL);
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	old_value = duplicity_job_get_state (self);
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
	if (old_value != value) {
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
		self->priv->_state = value;
#line 23 "../libdeja/duplicity/DuplicityJob.vala"
		g_object_notify_by_pspec ((GObject *) self, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY]);
#line 7741 "DuplicityJob.c"
	}
}

static void
duplicity_job_date_info_copy (const DuplicityJobDateInfo* self,
                              DuplicityJobDateInfo* dest)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	(*dest).full = (*self).full;
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = (*self).time;
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	_g_date_time_unref0 ((*dest).time);
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	(*dest).time = _tmp1_;
#line 7761 "DuplicityJob.c"
}

static void
duplicity_job_date_info_destroy (DuplicityJobDateInfo* self)
{
#line 47 "../libdeja/duplicity/DuplicityJob.vala"
	_g_date_time_unref0 ((*self).time);
#line 7769 "DuplicityJob.c"
}

static DuplicityJobDateInfo*
duplicity_job_date_info_dup (const DuplicityJobDateInfo* self)
{
	DuplicityJobDateInfo* dup;
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	dup = g_new0 (DuplicityJobDateInfo, 1);
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_date_info_copy (self, dup);
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	return dup;
#line 7782 "DuplicityJob.c"
}

static void
duplicity_job_date_info_free (DuplicityJobDateInfo* self)
{
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_date_info_destroy (self);
#line 45 "../libdeja/duplicity/DuplicityJob.vala"
	g_free (self);
#line 7792 "DuplicityJob.c"
}

 G_GNUC_NO_INLINE static GType
duplicity_job_date_info_get_type_once (void)
{
	GType duplicity_job_date_info_type_id;
	duplicity_job_date_info_type_id = g_boxed_type_register_static ("DuplicityJobDateInfo", (GBoxedCopyFunc) duplicity_job_date_info_dup, (GBoxedFreeFunc) duplicity_job_date_info_free);
	return duplicity_job_date_info_type_id;
}

static GType
duplicity_job_date_info_get_type (void)
{
	static gsize duplicity_job_date_info_type_id__once = 0;
	if (g_once_init_enter (&duplicity_job_date_info_type_id__once)) {
		GType duplicity_job_date_info_type_id;
		duplicity_job_date_info_type_id = duplicity_job_date_info_get_type_once ();
		g_once_init_leave (&duplicity_job_date_info_type_id__once, duplicity_job_date_info_type_id);
	}
	return duplicity_job_date_info_type_id__once;
}

static GObject *
duplicity_job_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DuplicityJob * self;
	GFile* _tmp0_;
#line 71 "../libdeja/duplicity/DuplicityJob.vala"
	parent_class = G_OBJECT_CLASS (duplicity_job_parent_class);
#line 71 "../libdeja/duplicity/DuplicityJob.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 71 "../libdeja/duplicity/DuplicityJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 72 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = duplicity_job_slash;
#line 72 "../libdeja/duplicity/DuplicityJob.vala"
	if (_tmp0_ == NULL) {
#line 7834 "DuplicityJob.c"
		GFile* _tmp1_;
#line 73 "../libdeja/duplicity/DuplicityJob.vala"
		_tmp1_ = g_file_new_for_path ("/");
#line 73 "../libdeja/duplicity/DuplicityJob.vala"
		_g_object_unref0 (duplicity_job_slash);
#line 73 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_slash = _tmp1_;
#line 7842 "DuplicityJob.c"
	}
#line 71 "../libdeja/duplicity/DuplicityJob.vala"
	return obj;
#line 7846 "DuplicityJob.c"
}

static void
duplicity_job_class_init (DuplicityJobClass * klass,
                          gpointer klass_data)
{
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_parent_class = g_type_class_peek_parent (klass);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_type_class_adjust_private_offset (klass, &DuplicityJob_private_offset);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->start = (void (*) (DejaDupToolJob*, GAsyncReadyCallback, gpointer)) duplicity_job_real_start;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->start_finish = (void (*) (DejaDupToolJob*, GAsyncResult*)) duplicity_job_start_finish;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->cancel = (void (*) (DejaDupToolJob*)) duplicity_job_real_cancel;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->stop = (void (*) (DejaDupToolJob*)) duplicity_job_real_stop;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->pause = (void (*) (DejaDupToolJob*, const gchar*)) duplicity_job_real_pause;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DejaDupToolJobClass *) klass)->resume = (void (*) (DejaDupToolJob*)) duplicity_job_real_resume;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_error = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_error;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_info = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_info;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	((DuplicityJobClass *) klass)->process_warning = (void (*) (DuplicityJob*, gchar**, gint, GList*, const gchar*)) duplicity_job_real_process_warning;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_duplicity_job_get_property;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_duplicity_job_set_property;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->constructor = duplicity_job_constructor;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (klass)->finalize = duplicity_job_finalize;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DUPLICITY_JOB_STATE_PROPERTY, duplicity_job_properties[DUPLICITY_JOB_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", DUPLICITY_JOB_TYPE_STATE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7885 "DuplicityJob.c"
}

static void
duplicity_job_instance_init (DuplicityJob * self,
                             gpointer klass)
{
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv = duplicity_job_get_instance_private (self);
#line 12 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->_error_issued = FALSE;
#line 13 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->_was_stopped = FALSE;
#line 29 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->is_full_backup = FALSE;
#line 30 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->cleaned_up_once = FALSE;
#line 31 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->detected_encryption = FALSE;
#line 32 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->existing_encrypted = FALSE;
#line 37 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->has_progress_total = FALSE;
#line 43 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->checked_collection_info = FALSE;
#line 44 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->got_collection_info = FALSE;
#line 49 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->collection_info = NULL;
#line 51 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->reported_full_backups = FALSE;
#line 53 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->checked_backup_space = FALSE;
#line 56 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->deleted_files = FALSE;
#line 57 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->delete_age = 0;
#line 59 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->last_touched_file = NULL;
#line 60 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->forced_cache_dir = NULL;
#line 61 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->credentials_dir = NULL;
#line 798 "../libdeja/duplicity/DuplicityJob.vala"
	self->priv->restarted_without_cache = FALSE;
#line 7930 "DuplicityJob.c"
}

static void
duplicity_job_finalize (GObject * obj)
{
	DuplicityJob * self;
	DejaDupNetwork* _tmp0_;
	DejaDupNetwork* _tmp1_;
	guint _tmp2_;
	GQuark _tmp3_;
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp0_ = deja_dup_network_get ();
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	_tmp1_ = _tmp0_;
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_parse_name ("notify::connected", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _duplicity_job_network_changed_g_object_notify, self);
#line 78 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (_tmp1_);
#line 79 "../libdeja/duplicity/DuplicityJob.vala"
	duplicity_job_clean_credentials_dir (self);
#line 25 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->inst);
#line 27 "../libdeja/duplicity/DuplicityJob.vala"
	(self->priv->saved_argv == NULL) ? NULL : (self->priv->saved_argv = (_g_list_free__g_free0_ (self->priv->saved_argv), NULL));
#line 28 "../libdeja/duplicity/DuplicityJob.vala"
	(self->priv->saved_envp == NULL) ? NULL : (self->priv->saved_envp = (_g_list_free__g_free0_ (self->priv->saved_envp), NULL));
#line 34 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->last_bad_volume);
#line 49 "../libdeja/duplicity/DuplicityJob.vala"
	(self->priv->collection_info == NULL) ? NULL : (self->priv->collection_info = (_g_list_free__duplicity_job_date_info_free0_ (self->priv->collection_info), NULL));
#line 59 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->last_touched_file);
#line 60 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->forced_cache_dir);
#line 61 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->credentials_dir);
#line 675 "../libdeja/duplicity/DuplicityJob.vala"
	_g_free0 (self->priv->saved_status);
#line 676 "../libdeja/duplicity/DuplicityJob.vala"
	_g_object_unref0 (self->priv->saved_status_file);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	G_OBJECT_CLASS (duplicity_job_parent_class)->finalize (obj);
#line 7977 "DuplicityJob.c"
}

 G_GNUC_NO_INLINE static GType
duplicity_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DuplicityJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) duplicity_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DuplicityJob), 0, (GInstanceInitFunc) duplicity_job_instance_init, NULL };
	GType duplicity_job_type_id;
	duplicity_job_type_id = g_type_register_static (DEJA_DUP_TYPE_TOOL_JOB, "DuplicityJob", &g_define_type_info, 0);
	DuplicityJob_private_offset = g_type_add_instance_private (duplicity_job_type_id, sizeof (DuplicityJobPrivate));
	return duplicity_job_type_id;
}

GType
duplicity_job_get_type (void)
{
	static gsize duplicity_job_type_id__once = 0;
	if (g_once_init_enter (&duplicity_job_type_id__once)) {
		GType duplicity_job_type_id;
		duplicity_job_type_id = duplicity_job_get_type_once ();
		g_once_init_leave (&duplicity_job_type_id__once, duplicity_job_type_id);
	}
	return duplicity_job_type_id__once;
}

static void
_vala_duplicity_job_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	switch (property_id) {
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		case DUPLICITY_JOB_STATE_PROPERTY:
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		g_value_set_enum (value, duplicity_job_get_state (self));
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		break;
#line 8018 "DuplicityJob.c"
		default:
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		break;
#line 8024 "DuplicityJob.c"
	}
}

static void
_vala_duplicity_job_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	DuplicityJob * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DUPLICITY_JOB, DuplicityJob);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
	switch (property_id) {
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		case DUPLICITY_JOB_STATE_PROPERTY:
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		duplicity_job_set_state (self, g_value_get_enum (value));
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		break;
#line 8044 "DuplicityJob.c"
		default:
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../libdeja/duplicity/DuplicityJob.vala"
		break;
#line 8050 "DuplicityJob.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

